//csc.exe /target:winexe /optimize users.cs
//.NET 4.8
using System;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing;
using System.IO;
using System.Text;
using System.Globalization;
using System.Net;
//using System.Net.Security;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Threading;

namespace AwemerApp {
	[DataContract]
	public class UserStatsData {
		[DataMember(Name = "diggCount")]
		public long DiggCount;
		[DataMember(Name = "followerCount")]
		public long FollowerCount;
		[DataMember(Name = "followingCount")]
		public long FollowingCount;
		//[DataMember(Name = "heart")]
		//public long Heart;
		[DataMember(Name = "heartCount")]
		public long HeartCount;
		[DataMember(Name = "videoCount")]
		public long VideoCount;
	}
	[DataContract]
	public class LinkData {
		[DataMember(Name = "link")]
		public string Link;
	}
	[DataContract]
	public class UserData_ {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "uniqueId")]
		public string UniqueId;
		//[DataMember(Name = "secUid")]
		//public string SecUid;
		//[DataMember(Name = "nickname")]
		//public string Nickname;
		//[DataMember(Name = "openFavorite")]
		//public bool OpenFavorite;
		//[DataMember(Name = "secret")]
		//public bool Secret;
		//[DataMember(Name = "verified")]
		//public bool Verified;
		//[DataMember(Name = "avatarLarger")]
		//public string AvatarLarger;
		//[DataMember(Name = "signature")]
		//public string Signature;
		//[DataMember(Name = "bioLink")]
		//public LinkData BioLink;
	}
	[DataContract]
	public class UserInfoData_ {
		//[DataMember(Name = "stats")]
		//public UserStatsData Stats;
		[DataMember(Name = "user")]
		public UserData_ User;
	}
	/*[DataContract]
	public class UserInfo {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		[DataMember(Name = "userInfo")]
		public UserInfoData_ UserInfo;
	}*/
	[DataContract]
	public class UserSearch {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		//[DataMember(Name = "offset")]
		//public long Offset;
		[DataMember(Name = "userInfoList")]
		public UserInfoData_[] UserInfoList;
	}
	[DataContract]
	public class UrlData {
		[DataMember(Name = "url_list")]
		public string[] UrlList;
	}
	[DataContract]
	public class MainData {
		[DataMember(Name = "hls")]
		public string Hls;
		[DataMember(Name = "flv")]
		public string Flv;
	}
	[DataContract]
	public class OriginData {
		[DataMember(Name = "main")]
		public MainData Main;
	}
	[DataContract]
	public class DataData {
		[DataMember(Name = "origin")]
		public OriginData Origin;
	}
	[DataContract]
	public class StreamData {
		[DataMember(Name = "data")]
		public DataData Data;
	}
	[DataContract]
	public class PullDataData {
		[DataMember(Name = "stream_data")]
		public string StreamData;
	}
	[DataContract]
	public class LiveCoreSdkDataData {
		[DataMember(Name = "pull_data")]
		public PullDataData PullData;
	}
	[DataContract]
	public class StreamUrlData {
		[DataMember(Name = "live_core_sdk_data")]
		public LiveCoreSdkDataData LiveCoreSdkData;
	}
	[DataContract]
	public class RoomData {
		[DataMember(Name = "stream_url")]
		public StreamUrlData StreamUrl;
	}
	[DataContract]
	public class UserData {
		[DataMember(Name = "uid")]
		public string Uid;
		[DataMember(Name = "unique_id")]
		public string UniqueId;
		[DataMember(Name = "sec_uid")]
		public string SecUid;
		[DataMember(Name = "nickname")]
		public string Nickname;
		[DataMember(Name = "aweme_count")]
		public long AwemeCount;
		[DataMember(Name = "favoriting_count")]
		public long FavoritingCount;
		[DataMember(Name = "total_favorited")]
		public long TotalFavorited;
		[DataMember(Name = "following_count")]
		public long FollowingCount;
		[DataMember(Name = "follower_count")]
		public long FollowerCount;
		[DataMember(Name = "secret")]
		public int Secret;
		[DataMember(Name = "avatar_larger")]
		public UrlData AvatarLarger;
		[DataMember(Name = "video_icon")]
		public UrlData VideoIcon;
		[DataMember(Name = "room_id")]
		public long RoomId;
		[DataMember(Name = "room_data")]
		public string RoomData;
		[DataMember(Name = "ins_id")]
		public string InsId;
		[DataMember(Name = "youtube_channel_id")]
		public string YoutubeChannelId;
		[DataMember(Name = "signature")]
		public string Signature;
		[DataMember(Name = "bio_url")]
		public string BioUrl;
	}
	[DataContract]
	public class UserInfoData {
		[DataMember(Name = "user")]
		public UserData User;
	}
	[DataContract]
	public class Followings_ {
		//[DataMember(Name = "status_code")]
		//public long StatusCode;
		[DataMember(Name = "has_more")]
		public bool HasMore;
		[DataMember(Name = "min_time")]
		public long MinTime;
		[DataMember(Name = "followings")]
		public UserData[] Followings;
		//[DataMember(Name = "total")]
		//public long Total;
	}
	[DataContract]
	public class Followers_ {
		//[DataMember(Name = "status_code")]
		//public long StatusCode;
		[DataMember(Name = "has_more")]
		public bool HasMore;
		[DataMember(Name = "min_time")]
		public long MinTime;
		[DataMember(Name = "followers")]
		public UserData[] Followers;
		//[DataMember(Name = "total")]
		//public long Total;
	}
	public struct List {
		public string Id;
		public long Limit;
		public long Cursor;
	}
	/*public class UnexpectedException: Exception {
		public UnexpectedException() {}
		public UnexpectedException(string message): base(message) {}
		public UnexpectedException(string message, Exception inner): base(message, inner) {}
	}*/
	public class AwemeWebClient: WebClient {
		protected override WebResponse GetWebResponse(WebRequest request) {
			(request as HttpWebRequest).AllowAutoRedirect = true;
			HttpWebResponse r = base.GetWebResponse(request) as HttpWebResponse;
			if (r.ContentLength == 0) {
				throw new Exception("Response body is empty.");
			}
			return r;
		}
		/*public bool DownloadNonEmptyFile(Uri uri, string filename, byte[] buffer) {
			int i;
			byte[] b;
			Stream s;
			FileStream f;
			using (s = OpenRead(uri)) {
				if ((i = s.ReadByte()) == -1) {
					return false;
				}
				b = buffer != null ? buffer : new byte[1024];
				using (f = new FileStream(filename, FileMode.Create)) {
					f.WriteByte((byte)i);
					while ((i = s.Read(b, 0, b.Length)) > 0) {
						f.Write(b, 0, i);
					}
					f.Flush();
				}
			}
			return true;
		}
		public bool DownloadNonEmptyFile(string uri, string filename, byte[] buffer) {
			return DownloadNonEmptyFile(new Uri(uri), filename, buffer);
		}*/
	}
	public class MainForm: Form {
		public bool Stop;
		public string DeviceId = GenerateDeviceId();//6672757199980234245
		public string IId = GenerateDeviceId();//6753521729043285766
		public string DeviceVersion = GenerateBase62(8);
		//public string Os = GenerateBase62(16);
		//public string Cookie = GenerateCookie();
		//public string Ip = "";
		public Graphics Graphics = null;
		public IContainer Components = new Container();
		public ToolTip Tip = new ToolTip();
		public Label TypeLabel = new Label();
		public ComboBox TypeInput = new ComboBox();
		public Label IdLabel = new Label();
		public TextBox IdInput = new TextBox();
		public Label LimitLabel = new Label();
		public TextBox LimitInput = new TextBox();
		public Label CursorLabel = new Label();
		public TextBox CursorInput = new TextBox();
		public Button Info = new Button();
		public Button List = new Button();
		public TextBox Output = new TextBox();
		public readonly object StopLock = new Object();
		public MainForm() {
			SuspendLayout();
			Components.Add(Tip);
			Graphics = CreateGraphics();
			int t, w = (int)Graphics.MeasureString("id/name:", IdLabel.Font).Width + 5;
			TypeLabel.AutoSize = false;
			TypeLabel.Size = new Size(w, 21);
			TypeLabel.Location = new Point(5, t = 5);
			TypeLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			TypeLabel.Text = "type:";
			TypeLabel.TextAlign = ContentAlignment.MiddleLeft;
			TypeInput.Size = new Size(210, 21);
			TypeInput.Location = new Point(2 * 5 + w, t);
			TypeInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			TypeInput.DropDownStyle = ComboBoxStyle.DropDownList;
			TypeInput.Items.Add("followings");
			TypeInput.Items.Add("followers");
			TypeInput.SelectedIndex = 0;
			IdLabel.AutoSize = false;
			IdLabel.Size = new Size(w, 21);
			IdLabel.Location = new Point(5, t += 5 + 21);
			IdLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			IdLabel.Text = "id/name:";
			IdLabel.TextAlign = ContentAlignment.MiddleLeft;
			IdInput.Size = new Size(210, 21);
			IdInput.Location = new Point(2 * 5 + w, t);
			IdInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			LimitLabel.AutoSize = false;
			LimitLabel.Size = new Size(w, 21);
			LimitLabel.Location = new Point(5, t += 5 + 21);
			LimitLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			LimitLabel.Text = "max:";
			LimitLabel.TextAlign = ContentAlignment.MiddleLeft;
			LimitInput.Size = new Size(210, 21);
			LimitInput.Location = new Point(2 * 5 + w, t);
			LimitInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			CursorLabel.AutoSize = false;
			CursorLabel.Size = new Size(w, 21);
			CursorLabel.Location = new Point(5, t += 5 + 21);
			CursorLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			CursorLabel.Text = "cursor:";
			CursorLabel.TextAlign = ContentAlignment.MiddleLeft;
			CursorInput.Size = new Size(210, 21);
			CursorInput.Location = new Point(2 * 5 + w, t);
			CursorInput.Text = "0";
			CursorInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			w = 3 * 5 + w + 210;
			Info.Size = new Size(90, 21);
			Info.Location = new Point(w / 2 - 90 - 5, t += 5 + 21);
			Info.Anchor = (AnchorStyles)(AnchorStyles.Top);
			Info.Text = "info";
			Info.Click += InfoClick;
			List.Size = new Size(90, 21);
			List.Location = new Point(w / 2 + 5, t);
			List.Anchor = (AnchorStyles)(AnchorStyles.Top);
			List.Text = "list";
			List.Click += ListClick;
			Output.Size = new Size(w - 2 * 5, 210);
			Output.Location = new Point(5, t += 5 + 21);
			Output.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Bottom | AnchorStyles.Left);
			Output.Multiline = true;
			Output.ReadOnly = true;
			Output.BackColor = Color.FromKnownColor(KnownColor.Window);
			Output.WordWrap = false;
			Output.ScrollBars = ScrollBars.Both;
			Tip.ShowAlways = true;
			Tip.AutoPopDelay = 9000;
			Tip.InitialDelay = 300;
			Tip.ReshowDelay = 300;
			Tip.SetToolTip(TypeInput, "type");
			Tip.SetToolTip(IdInput, "id/name (id or @name) - id or name of a user");
			Tip.SetToolTip(LimitInput, "max (integer) - max number of users to list");
			Tip.SetToolTip(CursorInput, "cursor (integer) - unix time");
			Tip.SetToolTip(Output, "output (id|unique id or secure id|videos|favorites|favorited|followings|followers|signature)");
			ClientSize = new Size(w, t + 5 + 210);
			Text = "users";
			ShowIcon = false;
			Controls.Add(TypeLabel);
			Controls.Add(TypeInput);
			Controls.Add(IdLabel);
			Controls.Add(IdInput);
			Controls.Add(LimitLabel);
			Controls.Add(LimitInput);
			Controls.Add(CursorLabel);
			Controls.Add(CursorInput);
			Controls.Add(Info);
			Controls.Add(List);
			Controls.Add(Output);
			ResumeLayout(false);
			PerformLayout();
			Show();
			MinimumSize = Size;
			IdInput.Focus();
		}
		protected override void Dispose(bool disposing) {
			if (disposing) {
				if (Graphics != null) {
					Graphics.Dispose();
				}
				if (Components != null) {
					Components.Dispose();
				}
			}
			base.Dispose(disposing);
		}
		public void DisableControls() {
			Stop = false;
			Info.Text = "stop";
			List.Text = "stop";
			TypeInput.Enabled = false;
			IdInput.ReadOnly = true;
			LimitInput.ReadOnly = true;
			CursorInput.ReadOnly = true;
			Cursor.Current = Cursors.WaitCursor;
		}
		public void EnableControls() {
			Stop = false;
			Info.Text = "info";
			List.Text = "list";
			TypeInput.Enabled = true;
			IdInput.ReadOnly = false;
			LimitInput.ReadOnly = false;
			CursorInput.ReadOnly = false;
			Cursor.Current = Cursors.Default;
		}
		public static double Max(params double[] values) {
			if (values.Length == 0) {
				return 0;
			}
			int i = 0;
			double m = values[0];
			do {
				if (m < values[i]) {
					m = values[i];
				}
				i++;
			} while (i < values.Length);
			return m;
		}
		public static string ReplaceNewlines(string value, string replacement) {
			if (value.Length == 0) {
				return "";
			}
			int i = 0;
			switch (replacement.Length) {
				case 0: {
					char[] r = new char[value.Length];
					int e = 0;
					do {
						switch (value[i]) {
							case '\r':
							case '\n':
								break;
							default:
								r[e] = value[i];
								e++;
								break;
						}
						i++;
					} while (i < value.Length);
					return new string(r, 0, e);
				}
				case 1: {
					char[] r = new char[value.Length];
					int e = 0;
					do {
						switch (value[i]) {
							case '\r':
								r[e] = replacement[0];
								e++;
								i++;
								if (i == value.Length) {
									goto end;
								} else if (value[i] == '\n') {
									i++;
								}
								break;
							case '\n':
								r[e] = replacement[0];
								e++;
								i++;
								break;
							default:
								r[e] = value[i];
								e++;
								i++;
								break;
						}
					} while (i < value.Length);
					end: return new string(r, 0, e);
				}
				default: {
					StringBuilder r = new StringBuilder(replacement.Length);
					do {
						switch (value[i]) {
							case '\r':
								r.Append(replacement);
								i++;
								if (i == value.Length) {
									goto end;
								} else if (value[i] == '\n') {
									i++;
								}
								break;
							case '\n':
								r.Append(replacement);
								i++;
								break;
							default:
								r.Append(value[i]);
								i++;
								break;
						}
					} while (i < value.Length);
					end: return r.ToString();
				}
			}
		}
		public static object FromJson(DataContractJsonSerializer serializer, string value) {
			using (MemoryStream t = new MemoryStream(Encoding.UTF8.GetBytes(value))) {
				return serializer.ReadObject(t);
			}
		}
		public static string ToJson(DataContractJsonSerializer serializer, object value) {
			using (MemoryStream t = new MemoryStream()) {
				serializer.WriteObject(t, value);
				return Encoding.UTF8.GetString(t.ToArray());
			}
		}
		public static string GenerateBase62(int length) {
			const string base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			int i = 0;
			char[] a = new char[length];
			Random r = new Random();
			while (i < length) {
				a[i] = base62[r.Next(62)];
				i++;
			}
			return new string(a);
		}
		public static string GenerateDeviceId() {
			int i = 1;
			Random r = new Random();
			char[] a = new char[19];//11 + r.Next(9)
			a[0] = '6';//(char)(49 + r.Next(9))
			while (i < a.Length) {
				a[i] = (char)(48 + r.Next(10));
				i++;
			}
			return new string(a);
		}
		/*public static string ToBase36(long value) {
			if (value == long.MinValue) {
				return "-1y2p0ij32e8e8";
			}
			const string base36 = "0123456789abcdefghijklmnopqrstuvwxyz";
			bool n;
			int i = 13;
			char[] a = new char[14];
			if (n = value < 0) {
				value = -value;
			}
			do {
				a[i--] = base36[(byte)(value % 36)];
			} while ((value /= 36) != 0);
			if (n) {
				a[i--] = '-';
			}
			return new string(a, i + 1, 13 - i);
		}
		public static string GenerateVerify() {
			const string base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			int i = 0;
			long t = (long)DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1)).TotalMilliseconds;
			char[] a = new char[36];
			Random r = new Random();
			do {
				switch (i) {
					case 8:
					case 13:
					case 18:
					case 23:
						a[i] = '_';
						break;
					case 14:
						a[i] = '4';
						break;
					default:
						a[i] = base62[r.Next(62)];
						break;
				}
				i++;
			} while (i < 36);
			return "verify_" + ToBase36(t) + "_" + new string(a);
		}
		public static string GenerateCookie() {
			string t = GenerateDeviceId();
			return "tt_webid=" + t + "; tt_webid_v2=" + t + "; tt_csrf_token=" + GenerateBase62(24) + "; s_v_web_id=" + GenerateVerify();
		}*/
		/*public static string GeneratePublicIp() {
			int i0, i1, i2;
			Random r = new Random();
			while ((i0 = r.Next(1, 224)) == 10 || i0 == 127) {}
			switch (i0) {
				case 100:
					while ((i1 = r.Next(256)) > 63 && i1 < 128) {}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 169:
					while ((i1 = r.Next(256)) == 254) {}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 172:
					while ((i1 = r.Next(256)) > 15 && i1 < 32) {}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 192:
					while ((i1 = r.Next(256)) == 168) {}
					switch (i1) {
						case 0:
							while ((i2 = r.Next(1, 256)) == 2) {}
							return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
						case 88:
							while ((i2 = r.Next(256)) == 99) {}
							return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
					}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 198:
					while ((i1 = r.Next(256)) == 18 || i1 == 19) {}
					if (i1 == 51) {
						while ((i2 = r.Next(256)) == 100) {}
						return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
					}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 203:
					if ((i1 = r.Next(256)) == 0) {
						while ((i2 = r.Next(256)) == 113) {}
						return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
					}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
			}
			return i0.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
		}*/
		/*public static string GenerateIp() {
			Random r = new Random();
			return r.Next(0, 256).ToString() + '.' + r.Next(0, 256).ToString() + '.' + r.Next(0, 256).ToString() + '.' + r.Next(0, 256).ToString();
		}*/
		public static bool ValidateUniqueId(string value) {
			for (int i = 0; i < value.Length; i++) {
				if ((value[i] < '0' || value[i] > '9')
				&& (value[i] < 'A' || value[i] > 'Z')
				&& (value[i] < 'a' || value[i] > 'z')) {
					switch (value[i]) {
						case '_':
						case '.':
							break;
						default:
							return false;
					}
				}
			}
			return true;
		}
		public static bool ValidateId(string value) {
			if (value.Length == 0 || value.Length > 20 || value[0] < '1' || value[0] > '9') {
				return false;
			}
			for (int i = 1; i < value.Length; i++) {
				if (value[i] < '0' || value[i] > '9') {
					return false;
				}
			}
			return true;
		}
		public static string GetRedirect(string url) {
			int i = 0;
			string r = url;
			HttpWebRequest rq;
			HttpWebResponse rs;
			do {
				rq = (HttpWebRequest)HttpWebRequest.Create(url);
				rq.Method = "GET";
				rq.AllowAutoRedirect = false;
				rq.UserAgent = "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36";
				using (rs = (HttpWebResponse)rq.GetResponse()) {
					if ((int)rs.StatusCode < 300 || (int)rs.StatusCode >= 400) {
						break;
					} else if ((r = rs.Headers.Get("Location")) == null) {
						r = url;
						break;
					} else if (r.IndexOf("://") == -1) {
						r = (new Uri(new Uri(url), r)).ToString();
					}
				}
				url = r;
				i++;
			} while (i < 9);
			return r;
		}
		public bool RequestAweme(WebClient client, DataContractJsonSerializer serializer, string path, out object result) {
			int r = 0;
			TimeSpan t;
			Stream s;
			Thread.Sleep(1000);
			do {
				lock (StopLock) {
					if (Stop) {
						break;
					}
				}
				t = DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1));
				try {
					client.Headers.Set("User-Agent", "okhttp");
					/*if (Ip.Length > 0) {
						client.Headers.Set("X-Forwarded-For", Ip);
					}*/
					using (s = client.OpenRead("https://api-t2.tiktokv.com" + path
					+ "&region=US"
					//+ "&version_name=10.0.1"
					+ "&ts=" + ((int)t.TotalSeconds).ToString()
					+ "&timezone_name=Etc%2FGMT"
					+ "&device_type=Pixel%20" + DeviceVersion
					+ "&iid=" + IId
					+ "&locale=en"
					+ "&app_type=normal"
					//+ "&build_number=10.0.1"
					+ "&resolution=1080*1920"
					+ "&aid=1180"
					+ "&app_name=musical_ly"
					+ "&_rticket=" + ((long)t.TotalMilliseconds).ToString()
					+ "&device_platform=android"
					+ "&version_code=100001"
					+ "&dpi=441"
					+ "&cpu_support64=false"
					+ "&sys_region=US"
					+ "&timezone_offset=0"
					+ "&device_id=" + DeviceId
					+ "&pass-route=1"
					+ "&device_brand=google"
					+ "&os_version=8.0.1"
					//+ "&ab_version=10.0.1"
					+ "&op_region=US"
					+ "&app_language=en"
					+ "&pass-region=1"
					+ "&language=en"
					+ "&channel=googleplay")) {//+ "&version_name=10.0.1&build_number=10.0.1"
						result = serializer.ReadObject(s);
						return true;
					}
				} catch {
					//Os = GenerateBase62(16);
					//Ip = GeneratePublicIp();
					DeviceId = GenerateDeviceId();
					IId = GenerateDeviceId();
					DeviceVersion = GenerateBase62(8);
					if (r == 32) {//SerializationException or else
						//Ip = "";
						throw;
					}
					r++;
				}
			} while (true);
			result = null;
			return false;
		}
		public bool RequestTiktok(WebClient client, DataContractJsonSerializer serializer, string path, out object result) {
			int r = 0;
			Stream s;
			//Thread.Sleep(1000);
			do {
				lock (StopLock) {
					if (Stop) {
						break;
					}
				}
				try {
					client.Headers.Set("User-Agent", "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36");
					client.Headers.Set("Referer", "https://www.tiktok.com/");
					//client.Headers.Set("Cookie", Cookie);
					using (s = client.OpenRead("https://www.tiktok.com" + path)) {
						result = serializer.ReadObject(s);
						return true;
					}
				} catch {
					//Cookie = GenerateCookie();
					if (r == 9) {//SerializationException or else
						throw;
					}
					r++;
				}
			} while (true);
			result = null;
			return false;
		}
		/*public static string GetFlvStream(string value) {
			int i = value.IndexOf("-hls-"), e;
			if (i > -1 && ((e = value.IndexOf("/playlist.m3u8", i + 5)) > -1 || (e = value.IndexOf("/index.m3u8", i + 5)) > -1)) {
				return value.Substring(0, i) + "-flv-" + value.Substring(i + 5, e - i - 5) + ".flv";
			}
			return "";
		}
		public static string FindStream(string value) {
			/*int i = value.IndexOf("<script id=\"RENDER_DATA\" type=\"application/json\">"), e;
			if (i == -1 || (e = value.IndexOf("</script>", i += 49)) == -1) {
				return "";
			}
			value = Uri.UnescapeDataString(value.Substring(i, e - i));* /
			int i = value.IndexOf("\"LiveUrl\""), e;
			if (i == -1) {
				return "";
			}
			e = i + 9;
			while (e < value.Length && (value[e] == ' ' || value[e] == '\n' || value[e] == '\r' || value[e] == '\t')) {
				e++;
			}
			if (e == value.Length || value[e] != ':') {
				return "";
			}
			e++;
			while (e < value.Length && (value[e] == ' ' || value[e] == '\n' || value[e] == '\r' || value[e] == '\t')) {
				e++;
			}
			if (e == value.Length || value[e] != '"') {
				return "";
			}
			e++;
			i = e;
			while (e < value.Length && value[e] != '"') {
				e++;
			}
			if (e == value.Length) {
				return "";
			}
			return value.Substring(i, e - i);
		}
		public static string RequestStream(long id) {
			try {
				WebClient c = new WebClient();
				c.Headers.Set("User-Agent", "okhttp");
				return FindStream(c.DownloadString("https://www.tiktok.com/share/live/" + id.ToString()));
			} catch (Exception) {
				return "";
			}
		}*/
		/*public bool GetUserId(string name, out string result) {
			object r;
			UserNode o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(UserNode)), "/node/share/user/@" + Uri.EscapeUriString(name), out r)) {
				result = null;
				return false;
			}
			result = (o = (UserNode)r) != null && o.UserInfo != null && o.UserInfo.User != null ? o.UserInfo.User.Id : null;
			return true;
		}*/
		public bool GetUserId(string name, out string result) {
			int i;
			object r;
			UserSearch o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(UserSearch)), "/api/discover/user/"
			+ "?discoverType=1"
			+ "&needItemList=false"
			+ "&useRecommend=false"
			+ "&keyWord=" + Uri.EscapeDataString(name)
			+ "&offset=0"
			+ "&count=20"
			+ "&aid=1988"
			+ "&appId=1233"
			+ "&appType=m"
			+ "&app_name=tiktok_web"
			+ "&device_platform=web"
			+ "&language=en", out r)) {
				result = null;
				return false;
			} else if ((o = (UserSearch)r) != null && o.UserInfoList != null) {
				for (i = 0, name = name.ToLower(); i < o.UserInfoList.Length; i++) {
					if (o.UserInfoList[i].User != null && o.UserInfoList[i].User.UniqueId != null && o.UserInfoList[i].User.UniqueId.ToLower() == name) {
						result = o.UserInfoList[i].User.Id;
						return true;
					}
				}
			}
			result = null;
			return true;
		}
		/*public void OutputLiveInfo(string roomId) {
			if (roomId == null) {
				return;
			}
			string t;
			if ((t = RequestStream(roomId)).Length > 0) {
				Output.AppendText("hls stream: ");
				Output.AppendText(t);
				Output.AppendText(Environment.NewLine);
				t = GetFlvStream(t);
				if (t.Length > 0) {
					Output.AppendText("flv stream: ");
					Output.AppendText(t);
					Output.AppendText(Environment.NewLine);
				}
			}
		}*/
		public void OutputLiveInfo(string roomData) {
			if (roomData == null) {
				return;
			}
			RoomData rd = (RoomData)FromJson(new DataContractJsonSerializer(typeof(RoomData)), roomData);
			StreamData sd;
			if (rd == null || rd.StreamUrl == null || rd.StreamUrl.LiveCoreSdkData == null || rd.StreamUrl.LiveCoreSdkData.PullData == null || rd.StreamUrl.LiveCoreSdkData.PullData.StreamData == null) {
				return;
			}
			sd = (StreamData)FromJson(new DataContractJsonSerializer(typeof(StreamData)), rd.StreamUrl.LiveCoreSdkData.PullData.StreamData);
			if (sd == null || sd.Data == null || sd.Data.Origin == null || sd.Data.Origin.Main == null) {
				return;
			}
			if (sd.Data.Origin.Main.Hls != null && sd.Data.Origin.Main.Hls.Length > 0) {
				Output.AppendText("hls stream: ");
				Output.AppendText(sd.Data.Origin.Main.Hls);
				Output.AppendText(Environment.NewLine);
			}
			if (sd.Data.Origin.Main.Flv != null && sd.Data.Origin.Main.Flv.Length > 0) {
				Output.AppendText("flv stream: ");
				Output.AppendText(sd.Data.Origin.Main.Flv);
				Output.AppendText(Environment.NewLine);
			}
		}
		public void OutputUserInfo(UserData user) {
			Output.AppendText("id: ");
			Output.AppendText(user.Uid);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("unique id: ");
			Output.AppendText(user.UniqueId);
			Output.AppendText(Environment.NewLine);
			if (user.SecUid != null && user.SecUid.Length > 0) {
				Output.AppendText("secure id: ");
				Output.AppendText(user.SecUid);
				Output.AppendText(Environment.NewLine);
			}
			Output.AppendText("nickname: ");
			Output.AppendText(user.Nickname);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("private: ");
			Output.AppendText(user.Secret != 0 ? "true" : "false");
			Output.AppendText(Environment.NewLine);
			Output.AppendText("videos: ");
			Output.AppendText(user.AwemeCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("favorites: ");
			Output.AppendText(user.FavoritingCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("favorited: ");
			Output.AppendText(user.TotalFavorited.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("followings: ");
			Output.AppendText(user.FollowingCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("followers: ");
			Output.AppendText(user.FollowerCount.ToString());
			Output.AppendText(Environment.NewLine);
			if (user.AvatarLarger != null && user.AvatarLarger.UrlList != null && user.AvatarLarger.UrlList.Length > 0 && user.AvatarLarger.UrlList[0] != null) {
				Output.AppendText("avatar: ");
				Output.AppendText(user.AvatarLarger.UrlList[0]);
				Output.AppendText(Environment.NewLine);
			}
			if (user.VideoIcon != null && user.VideoIcon.UrlList != null && user.VideoIcon.UrlList.Length > 0 && user.VideoIcon.UrlList[0] != null) {
				Output.AppendText("dynamic avatar: ");
				Output.AppendText(user.VideoIcon.UrlList[0]);
				Output.AppendText(Environment.NewLine);
			}
			if (user.RoomId != 0) {
				Output.AppendText("live: ");
				Output.AppendText(user.RoomId.ToString());
				Output.AppendText(Environment.NewLine);
				try {
					OutputLiveInfo(user.RoomData);//user.RoomId
				} catch (Exception) {}
			}
			if (user.Signature != null && user.Signature.Length > 0) {
				Output.AppendText(ReplaceNewlines(user.Signature, Environment.NewLine));
				Output.AppendText(Environment.NewLine);
			}
			if (user.InsId != null && user.InsId.Length > 0) {
				Output.AppendText("https://www.instagram.com/");
				Output.AppendText(user.InsId);
				Output.AppendText("/");
				Output.AppendText(Environment.NewLine);
			}
			if (user.YoutubeChannelId != null && user.YoutubeChannelId.Length > 0) {
				Output.AppendText("https://www.youtube.com/channel/");
				Output.AppendText(user.YoutubeChannelId);
				Output.AppendText(Environment.NewLine);
			}
			if (user.BioUrl != null && user.BioUrl.Length > 0) {
				Output.AppendText(user.BioUrl);
				Output.AppendText(Environment.NewLine);
			}
		}
		public string StringifyUserInfo(UserData user, StringBuilder buffer) {
			buffer.Length = 0;
			buffer.Append(user.Uid)
			.Append(' ').Append(ValidateUniqueId(user.UniqueId) ? user.UniqueId : user.SecUid)
			.Append(' ').Append(user.AwemeCount.ToString())
			.Append(' ').Append(user.FavoritingCount.ToString())
			.Append(' ').Append(user.TotalFavorited.ToString())
			.Append(' ').Append(user.FollowingCount.ToString())
			.Append(' ').Append(user.FollowerCount.ToString());
			if (user.Signature != null && user.Signature.Length > 0) {
				buffer.Append(' ').Append(ReplaceNewlines(user.Signature, " "));
			}
			/*if (user.BioUrl != null && user.BioUrl.Length > 0) {
				buffer.Append(' ').Append(user.BioUrl);
			}*/
			buffer.Append(Environment.NewLine);
			return buffer.ToString();
		}
		public void InfoUser(object idOrName) {
			try {
				string i = (string)idOrName;
				object r;
				UserInfoData o;
				if (i[0] == '@') {
					if (!GetUserId(i.Substring(1), out i)) {
						goto end;
					} else if (i == null) {
						throw new Exception("Data is null.");
					}
				}
				if (!RequestAweme(new WebClient(), new DataContractJsonSerializer(typeof(UserInfoData)), "/aweme/v1/user/"///aweme/v1/user/profile/other/
				+ "?user_id=" + i//sec_user_id
				+ "&address_book_access=1"
				+ "&from=0", out r)) {
					goto end;
				} else if ((o = (UserInfoData)r) == null || o.User == null) {
					throw new Exception("Data is null.");
				}
				OutputUserInfo(o.User);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: EnableControls();
		}
		public void ListFollowings(object list) {
			long cu = 0;
			try {
				List d = (List)list;
				cu = d.Cursor;
				long i = 0, e = 0;
				object r;
				StringBuilder b = new StringBuilder();
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(Followings_));
				Followings_ o;
				if (d.Id[0] == '@') {
					if (!GetUserId(d.Id.Substring(1), out d.Id)) {
						goto end;
					} else if (d.Id == null) {
						throw new Exception("Data is null.");
					}
				}
				do {
					if (!RequestAweme(c, js, "/aweme/v1/user/following/list/"
					+ "?user_id=" + d.Id//sec_user_id
					+ "&max_time=" + cu.ToString()
					+ "&count=30"
					+ "&offset=0"
					+ "&source_type=1"
					+ "&address_book_access=1", out r)) {
						break;
					}
					o = (Followings_)r;
					if (o == null) {
						Output.AppendText("Data is null.");
						Output.AppendText(Environment.NewLine);
						break;
					} else if (o.Followings != null) {
						for (i = 0; i < o.Followings.Length; i++, e++) {
							if (e == d.Limit) {
								o.HasMore = false;
								break;
							}
							try {
								Output.AppendText(StringifyUserInfo(o.Followings[i], b));
							} catch (NullReferenceException) {}
						}
					}
					if (!o.HasMore) {
						break;
					}
					cu = o.MinTime;
				} while (true);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: Output.AppendText("cursor is ");
			Output.AppendText(cu.ToString());
			Output.AppendText(Environment.NewLine);
			EnableControls();
		}
		public void ListFollowers(object list) {
			long cu = 0;
			try {
				List d = (List)list;
				cu = d.Cursor;
				long i = 0, e = 0;
				object r;
				StringBuilder b = new StringBuilder();
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(Followers_));
				Followers_ o;
				if (d.Id[0] == '@') {
					if (!GetUserId(d.Id.Substring(1), out d.Id)) {
						goto end;
					} else if (d.Id == null) {
						throw new Exception("Data is null.");
					}
				}
				do {
					if (!RequestAweme(c, js, "/aweme/v1/user/follower/list/"
					+ "?user_id=" + d.Id//sec_user_id
					+ "&max_time=" + cu.ToString()
					+ "&count=30"
					+ "&offset=0"
					+ "&source_type=1"
					+ "&address_book_access=1", out r)) {
						break;
					}
					o = (Followers_)r;
					if (o == null) {
						Output.AppendText("Data is null.");
						Output.AppendText(Environment.NewLine);
						break;
					} else if (o.Followers != null) {
						for (i = 0; i < o.Followers.Length; i++, e++) {
							if (e == d.Limit) {
								o.HasMore = false;
								break;
							}
							try {
								Output.AppendText(StringifyUserInfo(o.Followers[i], b));
							} catch (NullReferenceException) {}
						}
					}
					if (!o.HasMore) {
						break;
					}
					cu = o.MinTime;
				} while (true);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: Output.AppendText("cursor is ");
			Output.AppendText(cu.ToString());
			Output.AppendText(Environment.NewLine);
			EnableControls();
		}
		public void InfoClick(object sender, EventArgs args) {
			lock (StopLock) {
				Stop = true;
				if (IdInput.ReadOnly) {
					return;
				}
			}
			DisableControls();
			if (IdInput.Text.Length == 0) {
				MessageBox.Show("Id or name is empty.");
				goto end;
			} else if (IdInput.Text[0] == '@') {
				if (IdInput.Text.Length == 1) {
					MessageBox.Show("Name is empty.");
					goto end;
				}
			} else if (!ValidateId(IdInput.Text)) {
				MessageBox.Show("Id is not valid.");
				goto end;
			}
			Output.Text = "";
			new Thread(new ParameterizedThreadStart(InfoUser)).Start(IdInput.Text);
			return;
			end: EnableControls();
		}
		public void ListClick(object sender, EventArgs args) {
			lock (StopLock) {
				Stop = true;
				if (IdInput.ReadOnly) {
					return;
				}
			}
			DisableControls();
			long l, c;
			if (IdInput.Text.Length == 0) {
				MessageBox.Show("Id or name is empty.");
				goto end;
			} else if (IdInput.Text[0] == '@') {
				if (IdInput.Text.Length == 1) {
					MessageBox.Show("Name is empty.");
					goto end;
				} else if (LimitInput.Text.Length == 0) {
					l = -1;
				} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
					MessageBox.Show("Max is not valid.");
					goto end;
				}
			} else if (ValidateId(IdInput.Text)) {
				if (LimitInput.Text.Length == 0) {
					l = -1;
				} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
					MessageBox.Show("Max is not valid.");
					goto end;
				}
			} else {
				MessageBox.Show("Id is not valid.");
				goto end;
			}
			if (!Int64.TryParse(CursorInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out c)) {
				MessageBox.Show("Cursor is not valid integer.");
				goto end;
			}
			Output.Text = "";
			new Thread(TypeInput.SelectedIndex == 0 ? new ParameterizedThreadStart(ListFollowings) : new ParameterizedThreadStart(ListFollowers)).Start(new List {
				Id = IdInput.Text,
				Limit = l,
				Cursor = c
			});
			return;
			end: EnableControls();
		}
		/*public static bool ValidateRemoteCertificate(object sender, object certificate, object chain, SslPolicyErrors sslPolicyErrors) {
			return true;
		}*/
		[STAThread]
		public static void Main() {
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			ServicePointManager.SecurityProtocol |= SecurityProtocolType.Ssl3 | SecurityProtocolType.Tls | SecurityProtocolType.Tls11 | SecurityProtocolType.Tls12 | SecurityProtocolType.Tls13;//.NET 4.8
			//ServicePointManager.ServerCertificateValidationCallback += ValidateRemoteCertificate;//.NET 3.5
			Application.Run(new MainForm());
		}
	}
}