//csc.exe /target:winexe /optimize videos-node.cs
//.NET 4.8
using System;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing;
using System.IO;
using System.Text;
using System.Globalization;
using System.Collections.Generic;
using System.Net;
//using System.Net.Security;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Threading;

namespace AwemerApp {
	[DataContract]
	public class UrlData {
		[DataMember(Name = "url_list")]
		public string[] UrlList;
	}
	[DataContract]
	public class VideoData_ {
		[DataMember(Name = "play_addr")]
		public UrlData PlayAddr;
		//[DataMember(Name = "play_addr_264")]
		//public UrlData PlayAddr264;
		[DataMember(Name = "play_addr_265")]
		public UrlData PlayAddr265;
		[DataMember(Name = "play_addr_bytevc1")]
		public UrlData PlayAddrBytevc1;
	}
	[DataContract]
	public class AwemeDetailData {
		[DataMember(Name = "aweme_id")]
		public string AwemeId;
		[DataMember(Name = "create_time")]
		public long CreateTime;
		[DataMember(Name = "desc")]
		public string Desc;
		[DataMember(Name = "video")]
		public VideoData_ Video;
	}
	[DataContract]
	public class AwemeData {
		//[DataMember(Name = "status_code")]
		//public long StatusCode;
		[DataMember(Name = "aweme_detail")]
		public AwemeDetailData AwemeDetail;
	}
	[DataContract]
	public class AwemesData {
		//[DataMember(Name = "status_code")]
		//public long StatusCode;
		[DataMember(Name = "aweme_details")]
		public AwemeDetailData[] AwemeDetails;
	}
	[DataContract]
	public class VideoData {
		//[DataMember(Name = "id")]
		//public string Id;
		[DataMember(Name = "cover")]
		public string Cover;
		[DataMember(Name = "dynamicCover")]
		public string DynamicCover;
		[DataMember(Name = "playAddr")]
		public string PlayAddr;
	}
	/*[DataContract]
	public class VideoData_ {
		[DataMember(Name = "urls")]
		public string[] Urls;
	}*/
	[DataContract]
	public class ItemInfosData {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "createTime")]
		public string CreateTime;
		[DataMember(Name = "text")]
		public string Text;
		//[DataMember(Name = "video")]
		//public VideoData_ Video;
	}
	[DataContract]
	public class ItemListDataData {
		[DataMember(Name = "itemInfos")]
		public ItemInfosData ItemInfos;
	}
	[DataContract]
	public class BodyData {
		[DataMember(Name = "hasMore")]
		public bool HasMore;
		[DataMember(Name = "maxCursor")]
		public string MaxCursor;
		[DataMember(Name = "itemListData")]
		public ItemListDataData[] ItemListData;
	}
	[DataContract]
	public class VideosResponse {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		[DataMember(Name = "body")]
		public BodyData Body;
	}
	[DataContract]
	public class UserStatsData {
		[DataMember(Name = "diggCount")]
		public long DiggCount;
		[DataMember(Name = "followerCount")]
		public long FollowerCount;
		[DataMember(Name = "followingCount")]
		public long FollowingCount;
		//[DataMember(Name = "heart")]
		//public long Heart;
		[DataMember(Name = "heartCount")]
		public long HeartCount;
		[DataMember(Name = "videoCount")]
		public long VideoCount;
	}
	[DataContract]
	public class LinkData {
		[DataMember(Name = "link")]
		public string Link;
	}
	[DataContract]
	public class UserData {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "uniqueId")]
		public string UniqueId;
		[DataMember(Name = "secUid")]
		public string SecUid;
		[DataMember(Name = "nickname")]
		public string Nickname;
		[DataMember(Name = "createTime")]
		public long CreateTime;
		[DataMember(Name = "openFavorite")]
		public bool OpenFavorite;
		[DataMember(Name = "secret")]
		public bool Secret;
		[DataMember(Name = "verified")]
		public bool Verified;
		[DataMember(Name = "avatarLarger")]
		public string AvatarLarger;
		[DataMember(Name = "signature")]
		public string Signature;
		[DataMember(Name = "bioLink")]
		public LinkData BioLink;
	}
	[DataContract]
	public class UserInfoData {
		[DataMember(Name = "stats")]
		public UserStatsData Stats;
		[DataMember(Name = "user")]
		public UserData User;
	}
	[DataContract]
	public class UserInfoResponse {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		[DataMember(Name = "userInfo")]
		public UserInfoData UserInfo;
	}
	[DataContract]
	public class MusicStatsData {
		[DataMember(Name = "videoCount")]
		public long VideoCount;
	}
	[DataContract]
	public class MusicData_ {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "title")]
		public string Title;
		[DataMember(Name = "authorName")]
		public string AuthorName;
		[DataMember(Name = "coverLarge")]
		public string CoverLarge;
		[DataMember(Name = "playUrl")]
		public string PlayUrl;
	}
	[DataContract]
	public class MusicInfoData {
		[DataMember(Name = "stats")]
		public MusicStatsData Stats;
		[DataMember(Name = "music")]
		public MusicData_ Music;
		[DataMember(Name = "author")]
		public UserData Author;
	}
	[DataContract]
	public class MusicInfoResponse {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		[DataMember(Name = "musicInfo")]
		public MusicInfoData MusicInfo;
	}
	[DataContract]
	public class ChallengeStatsData {
		[DataMember(Name = "videoCount")]
		public long VideoCount;
		[DataMember(Name = "viewCount")]
		public long ViewCount;
	}
	[DataContract]
	public class ChallengeData_ {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "title")]
		public string Title;
		[DataMember(Name = "profileLarger")]
		public string ProfileLarger;
		[DataMember(Name = "desc")]
		public string Desc;
	}
	[DataContract]
	public class ChallengeInfoData {
		[DataMember(Name = "stats")]
		public ChallengeStatsData Stats;
		[DataMember(Name = "challenge")]
		public ChallengeData_ Challenge;
	}
	[DataContract]
	public class ChallengeInfoResponse {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		[DataMember(Name = "challengeInfo")]
		public ChallengeInfoData ChallengeInfo;
	}
	[DataContract]
	public class MusicData {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "title")]
		public string Title;
		[DataMember(Name = "authorName")]
		public string AuthorName;
		[DataMember(Name = "coverLarge")]
		public string CoverLarge;
		[DataMember(Name = "playUrl")]
		public string PlayUrl;
	}
	/*[DataContract]
	public class ChallengeData {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "title")]
		public string Title;
	}*/
	[DataContract]
	public class ItemStatsData {
		[DataMember(Name = "commentCount")]
		public long CommentCount;
		[DataMember(Name = "diggCount")]
		public long DiggCount;
		[DataMember(Name = "playCount")]
		public long PlayCount;
		[DataMember(Name = "shareCount")]
		public long ShareCount;
	}
	[DataContract]
	public class ItemStructData {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "createTime")]
		public long CreateTime;
		[DataMember(Name = "desc")]
		public string Desc;
		[DataMember(Name = "stats")]
		public ItemStatsData Stats;
		[DataMember(Name = "video")]
		public VideoData Video;
		[DataMember(Name = "music")]
		public MusicData Music;
		//[DataMember(Name = "challenges")]
		//public ChallengeData[] Challenges;
		[DataMember(Name = "author")]
		public UserData Author;
		[DataMember(Name = "authorStats")]
		public UserStatsData AuthorStats;
	}
	[DataContract]
	public class ItemInfoData {
		[DataMember(Name = "itemStruct")]
		public ItemStructData ItemStruct;
	}
	[DataContract]
	public class VideoInfoResponse {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		[DataMember(Name = "itemInfo")]
		public ItemInfoData ItemInfo;
	}
	public struct Aweme {
		public string Id;
		public long Date;
		public string Description;
		public string Url;
		public bool AddDate;
		public bool AddDescription;
	}
	public struct Download {
		public string Id;
		public long Limit;
		public bool IsMax;
		public long Cursor;
	}
	/*public class UnexpectedException: Exception {
		public UnexpectedException() {}
		public UnexpectedException(string message): base(message) {}
		public UnexpectedException(string message, Exception inner): base(message, inner) {}
	}*/
	public class AwemeWebClient: WebClient {
		protected override WebResponse GetWebResponse(WebRequest request) {
			(request as HttpWebRequest).AllowAutoRedirect = true;
			HttpWebResponse r = base.GetWebResponse(request) as HttpWebResponse;
			if (r.ContentLength == 0) {
				throw new Exception("Response body is empty.");
			}
			return r;
		}
		/*public bool DownloadNonEmptyFile(Uri uri, string filename, byte[] buffer) {
			int i;
			byte[] b;
			Stream s;
			FileStream f;
			using (s = OpenRead(uri)) {
				if ((i = s.ReadByte()) == -1) {
					return false;
				}
				b = buffer != null ? buffer : new byte[1024];
				using (f = new FileStream(filename, FileMode.Create)) {
					f.WriteByte((byte)i);
					while ((i = s.Read(b, 0, b.Length)) > 0) {
						f.Write(b, 0, i);
					}
					f.Flush();
				}
			}
			return true;
		}
		public bool DownloadNonEmptyFile(string uri, string filename, byte[] buffer) {
			return DownloadNonEmptyFile(new Uri(uri), filename, buffer);
		}*/
	}
	public class MainForm: Form {
		public string Root;
		public string Dir;
		public bool Stop;
		public bool Date;
		public bool Description;
		public bool Quality;
		public bool Hevc;
		public string DeviceId = GenerateDeviceId();//6672757199980234245
		public string IId = GenerateDeviceId();//6753521729043285766
		public string DeviceVersion = GenerateBase62(8);
		//public string Os = GenerateBase62(16);
		public string Cookie = GenerateCookie();
		//public string Ip = "";
		public int Count;
		public FileStream Logger = null;
		public Graphics Graphics = null;
		public IContainer Components = new Container();
		public ToolTip Tip = new ToolTip();
		public FolderBrowserDialog DirOpener = new FolderBrowserDialog();
		public OpenFileDialog FileOpener = new OpenFileDialog();
		public CheckBox Log = new CheckBox();
		public CheckBox AddDate = new CheckBox();
		public CheckBox AddDescription = new CheckBox();
		public CheckBox ImproveQuality = new CheckBox();
		public CheckBox PreferHevc = new CheckBox();
		public Label DirLabel = new Label();
		public TextBox DirInput = new TextBox();
		public Button OpenDir = new Button();
		public Label CookieLabel = new Label();
		public TextBox CookieInput = new TextBox();
		public Label TypeLabel = new Label();
		public ComboBox TypeInput = new ComboBox();
		public Label IdLabel = new Label();
		public TextBox IdInput = new TextBox();
		public Button OpenFile = new Button();
		public Label LimitLabel = new Label();
		public TextBox LimitInput = new TextBox();
		public Label CursorLabel = new Label();
		public TextBox CursorInput = new TextBox();
		public Button Info = new Button();
		public Button Download = new Button();
		public TextBox Output = new TextBox();
		public readonly object StopLock = new Object();
		public readonly object OutLock = new Object();
		public readonly object SyncLock = new Object();
		public MainForm(string root, string directory) {
			Root = root;
			Dir = directory;
			SuspendLayout();
			Components.Add(Tip);
			Components.Add(DirOpener);
			Components.Add(FileOpener);
			Graphics = CreateGraphics();
			int t, w = (int)Graphics.MeasureString("directory:", DirLabel.Font).Width + 5;
			DirOpener.RootFolder = Environment.SpecialFolder.Desktop;
			DirOpener.SelectedPath = Root + Path.DirectorySeparatorChar + Dir;
			FileOpener.Title = "Select a file";
			FileOpener.RestoreDirectory = true;
			FileOpener.Filter = "Text file (*.txt)|*.txt|Any file (*.*)|*.*";
			FileOpener.InitialDirectory = Root;
			Log.AutoSize = false;
			Log.Size = new Size((int)Graphics.MeasureString("log", Log.Font).Width + 24, 21);
			Log.Location = new Point(5, t = 5);
			Log.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			Log.Text = "log";
			AddDate.AutoSize = false;
			AddDate.Size = new Size((int)Graphics.MeasureString("add date", AddDate.Font).Width + 24, 21);
			AddDate.Location = new Point(5, t += 5 + 21);
			AddDate.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			AddDate.Text = "add date";
			AddDate.CheckedChanged += AddDateChanged;
			AddDescription.AutoSize = false;
			AddDescription.Size = new Size((int)Graphics.MeasureString("add description", AddDescription.Font).Width + 24, 21);
			AddDescription.Location = new Point(5, t += 5 + 21);
			AddDescription.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			AddDescription.Text = "add description";
			AddDescription.CheckedChanged += AddDescriptionChanged;
			ImproveQuality.AutoSize = false;
			ImproveQuality.Size = new Size((int)Graphics.MeasureString("improve quality", ImproveQuality.Font).Width + 24, 21);
			ImproveQuality.Location = new Point(5, t += 5 + 21);
			ImproveQuality.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			ImproveQuality.Text = "improve quality";
			ImproveQuality.CheckedChanged += ImproveQualityChanged;
			PreferHevc.AutoSize = false;
			PreferHevc.Size = new Size((int)Graphics.MeasureString("prefer HEVC/H.265", PreferHevc.Font).Width + 24, 21);
			PreferHevc.Location = new Point(5, t += 5 + 21);
			PreferHevc.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			PreferHevc.Text = "prefer HEVC/H.265";
			PreferHevc.CheckedChanged += PreferHevcChanged;
			DirLabel.AutoSize = false;
			DirLabel.Size = new Size(w, 21);
			DirLabel.Location = new Point(5, t += 5 + 21);
			DirLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			DirLabel.Text = "directory:";
			DirLabel.TextAlign = ContentAlignment.MiddleLeft;
			DirInput.Size = new Size(210 - 26, 21);
			DirInput.Location = new Point(2 * 5 + w, t);
			DirInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			DirInput.Text = Dir;
			DirInput.Leave += DirLeave;
			OpenDir.Size = new Size(21, 21);
			OpenDir.Location = new Point(2 * 5 + w + 210 - 21, t);
			OpenDir.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right);
			OpenDir.Text = "⯇";
			OpenDir.Click += OpenDirClick;
			CookieLabel.AutoSize = false;
			CookieLabel.Size = new Size(w, 21);
			CookieLabel.Location = new Point(5, t += 5 + 21);
			CookieLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			CookieLabel.Text = "cookie:";
			CookieLabel.TextAlign = ContentAlignment.MiddleLeft;
			CookieInput.Size = new Size(210, 21);
			CookieInput.Location = new Point(2 * 5 + w, t);
			CookieInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			CookieInput.Text = Cookie;
			CookieInput.Leave += CookieLeave;
			TypeLabel.AutoSize = false;
			TypeLabel.Size = new Size(w, 21);
			TypeLabel.Location = new Point(5, t += 5 + 21);
			TypeLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			TypeLabel.Text = "type:";
			TypeLabel.TextAlign = ContentAlignment.MiddleLeft;
			TypeInput.Size = new Size(210, 21);
			TypeInput.Location = new Point(2 * 5 + w, t);
			TypeInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			TypeInput.DropDownStyle = ComboBoxStyle.DropDownList;
			TypeInput.Items.Add("user videos");
			TypeInput.Items.Add("music videos");
			TypeInput.Items.Add("hashtag videos");
			TypeInput.Items.Add("videos");
			TypeInput.SelectedIndex = 0;
			TypeInput.SelectedIndexChanged += TypeSelectedIndexChanged;
			IdLabel.AutoSize = false;
			IdLabel.Size = new Size(w, 21);
			IdLabel.Location = new Point(5, t += 5 + 21);
			IdLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			IdLabel.Text = "id/name:";
			IdLabel.TextAlign = ContentAlignment.MiddleLeft;
			IdInput.Size = new Size(210, 21);
			IdInput.Location = new Point(2 * 5 + w, t);
			IdInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			OpenFile.Size = new Size(21, 21);
			OpenFile.Location = new Point(2 * 5 + w + 210 - 21, t);
			OpenFile.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right);
			OpenFile.Text = "⯇";
			OpenFile.Visible = false;
			OpenFile.Click += OpenFileClick;
			LimitLabel.AutoSize = false;
			LimitLabel.Size = new Size(w, 21);
			LimitLabel.Location = new Point(5, t += 5 + 21);
			LimitLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			LimitLabel.Text = "date/max:";
			LimitLabel.TextAlign = ContentAlignment.MiddleLeft;
			LimitInput.Size = new Size(210, 21);
			LimitInput.Location = new Point(2 * 5 + w, t);
			LimitInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			CursorLabel.AutoSize = false;
			CursorLabel.Size = new Size(w, 21);
			CursorLabel.Location = new Point(5, t += 5 + 21);
			CursorLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			CursorLabel.Text = "cursor:";
			CursorLabel.TextAlign = ContentAlignment.MiddleLeft;
			CursorInput.Size = new Size(210, 21);
			CursorInput.Location = new Point(2 * 5 + w, t);
			CursorInput.Text = "0";
			CursorInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			w = 3 * 5 + w + 210;
			Info.Size = new Size(90, 21);
			Info.Location = new Point(w / 2 - 90 - 5, t += 5 + 21);
			Info.Anchor = (AnchorStyles)(AnchorStyles.Top);
			Info.Text = "info";
			Info.Click += InfoClick;
			Download.Size = new Size(90, 21);
			Download.Location = new Point(w / 2 + 5, t);
			Download.Anchor = (AnchorStyles)(AnchorStyles.Top);
			Download.Text = "download";
			Download.Click += DownloadClick;
			Output.Size = new Size(w - 2 * 5, 210);
			Output.Location = new Point(5, t += 5 + 21);
			Output.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Bottom | AnchorStyles.Left);
			Output.Multiline = true;
			Output.ReadOnly = true;
			Output.BackColor = Color.FromKnownColor(KnownColor.Window);
			Output.WordWrap = false;
			Output.ScrollBars = ScrollBars.Both;
			Tip.ShowAlways = true;
			Tip.AutoPopDelay = 9000;
			Tip.InitialDelay = 300;
			Tip.ReshowDelay = 300;
			Tip.SetToolTip(DirInput, "directory");
			Tip.SetToolTip(CookieInput, "cookie http request header value of https://www.tiktok.com/");
			Tip.SetToolTip(TypeInput, "type");
			Tip.SetToolTip(IdInput, "id/name (id or @name) - id or name of a user");
			Tip.SetToolTip(LimitInput, "date/max (optional - YYYY-MM-DD or integer) - date until which to check videos or max number of videos to check");
			Tip.SetToolTip(CursorInput, "cursor (integer) - unix time in milliseconds");
			Tip.SetToolTip(Output, "output");
			ClientSize = new Size(w, t + 5 + 210);
			Text = "videos";
			ShowIcon = false;
			Controls.Add(Log);
			Controls.Add(AddDate);
			Controls.Add(AddDescription);
			Controls.Add(ImproveQuality);
			Controls.Add(PreferHevc);
			Controls.Add(DirLabel);
			Controls.Add(DirInput);
			Controls.Add(OpenDir);
			Controls.Add(CookieLabel);
			Controls.Add(CookieInput);
			Controls.Add(TypeLabel);
			Controls.Add(TypeInput);
			Controls.Add(IdLabel);
			Controls.Add(IdInput);
			Controls.Add(OpenFile);
			Controls.Add(LimitLabel);
			Controls.Add(LimitInput);
			Controls.Add(CursorLabel);
			Controls.Add(CursorInput);
			Controls.Add(Info);
			Controls.Add(Download);
			Controls.Add(Output);
			ResumeLayout(false);
			PerformLayout();
			Show();
			MinimumSize = Size;
			IdInput.Focus();
		}
		protected override void Dispose(bool disposing) {
			if (disposing) {
				if (Logger != null) {
					Logger.Close();
					Logger.Dispose();
				}
				if (Graphics != null) {
					Graphics.Dispose();
				}
				if (Components != null) {
					Components.Dispose();
				}
			}
			base.Dispose(disposing);
		}
		public void DisableControls() {
			Stop = false;
			Info.Text = "stop";
			Download.Text = "stop";
			Log.Enabled = false;
			AddDate.Enabled = false;
			AddDescription.Enabled = false;
			ImproveQuality.Enabled = false;
			PreferHevc.Enabled = false;
			DirInput.ReadOnly = true;
			OpenDir.Enabled = false;
			CookieInput.ReadOnly = true;
			TypeInput.Enabled = false;
			IdInput.ReadOnly = true;
			OpenFile.Enabled = false;
			LimitInput.ReadOnly = true;
			CursorInput.ReadOnly = true;
			Cursor.Current = Cursors.WaitCursor;
		}
		public void EnableControls() {
			if (Logger != null) {
				Logger.Close();
				Logger.Dispose();
				Logger = null;
			}
			Stop = false;
			Info.Text = "info";
			Download.Text = "download";
			Log.Enabled = true;
			AddDate.Enabled = true;
			AddDescription.Enabled = true;
			ImproveQuality.Enabled = true;
			PreferHevc.Enabled = true;
			DirInput.ReadOnly = false;
			OpenDir.Enabled = true;
			CookieInput.ReadOnly = false;
			TypeInput.Enabled = true;
			IdInput.ReadOnly = false;
			OpenFile.Enabled = true;
			LimitInput.ReadOnly = false;
			CursorInput.ReadOnly = false;
			Cursor.Current = Cursors.Default;
		}
		public static double Max(params double[] values) {
			if (values.Length == 0) {
				return 0;
			}
			int i = 0;
			double m = values[0];
			do {
				if (m < values[i]) {
					m = values[i];
				}
				i++;
			} while (i < values.Length);
			return m;
		}
		public static string GetFullDir(string directory, string root) {
			if (directory.Length == 0) {
				return root;
			}
			string t;
			switch (directory[directory.Length - 1]) {
				case '/':
				case '\\':
					if (directory.Length == 1) {
						return root;
					}
					t = directory.Substring(0, directory.Length - 1);
					break;
				default:
					t = directory;
					break;
			}
			return Path.GetFullPath(Path.IsPathRooted(t) ? t : root + Path.DirectorySeparatorChar + t);
		}
		public static string CreateTimeToString(long value) {
			return (new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).AddSeconds(value).ToString("yyyy-MM-dd HH':'mm':'ss");
		}
		public static string CreateTimeToFilename(long value) {
			return (new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).AddSeconds(value).ToString("yyyyMMddTHHmmssZ");
		}
		public static string CreateTimeToLog(long value) {
			return (new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).AddSeconds(value).ToString("yyyy-MM-ddTHH':'mm':'ssZ");
		}
		public static string SanitizeFilename(string value) {
			if (value.Length == 0) {
				return "";
			}
			int i = 0, e = 0;
			char[] r = new char[value.Length];
			do {
				switch (value[i]) {
					case '"':
					case '*':
					case '/':
					case ':':
					case '<':
					case '>':
					case '?':
					case '\\':
					case '|':
						break;
					default:
						if (value[i] >= ' ') {
							r[e] = value[i];
							e++;
						}
						break;
				}
				i++;
			} while (i < value.Length);
			return new string(r, 0, e);
		}
		public static string SanitizeLog(string value) {
			if (value.Length == 0) {
				return "";
			}
			int i = 0, e = 0;
			char[] r = new char[value.Length];
			do {
				switch (value[i]) {
					case '\r':
					case '\n':
						break;
					default:
						r[e] = value[i];
						e++;
						break;
				}
				i++;
			} while (i < value.Length);
			return new string(r, 0, e);
		}
		public static string ReplaceNewlines(string value, string replacement) {
			if (value.Length == 0) {
				return "";
			}
			int i = 0;
			switch (replacement.Length) {
				case 0: {
					char[] r = new char[value.Length];
					int e = 0;
					do {
						switch (value[i]) {
							case '\r':
							case '\n':
								break;
							default:
								r[e] = value[i];
								e++;
								break;
						}
						i++;
					} while (i < value.Length);
					return new string(r, 0, e);
				}
				case 1: {
					char[] r = new char[value.Length];
					int e = 0;
					do {
						switch (value[i]) {
							case '\r':
								r[e] = replacement[0];
								e++;
								i++;
								if (i == value.Length) {
									goto end;
								} else if (value[i] == '\n') {
									i++;
								}
								break;
							case '\n':
								r[e] = replacement[0];
								e++;
								i++;
								break;
							default:
								r[e] = value[i];
								e++;
								i++;
								break;
						}
					} while (i < value.Length);
					end: return new string(r, 0, e);
				}
				default: {
					StringBuilder r = new StringBuilder(replacement.Length);
					do {
						switch (value[i]) {
							case '\r':
								r.Append(replacement);
								i++;
								if (i == value.Length) {
									goto end;
								} else if (value[i] == '\n') {
									i++;
								}
								break;
							case '\n':
								r.Append(replacement);
								i++;
								break;
							default:
								r.Append(value[i]);
								i++;
								break;
						}
					} while (i < value.Length);
					end: return r.ToString();
				}
			}
		}
		public static string GenerateBase62(int length) {
			const string base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			int i = 0;
			char[] a = new char[length];
			Random r = new Random();
			while (i < length) {
				a[i] = base62[r.Next(62)];
				i++;
			}
			return new string(a);
		}
		public static string GenerateDeviceId() {
			int i = 1;
			Random r = new Random();
			char[] a = new char[19];//11 + r.Next(9)
			a[0] = '6';//(char)(49 + r.Next(9))
			while (i < a.Length) {
				a[i] = (char)(48 + r.Next(10));
				i++;
			}
			return new string(a);
		}
		public static string ToBase36(long value) {
			if (value == long.MinValue) {
				return "-1y2p0ij32e8e8";
			}
			const string base36 = "0123456789abcdefghijklmnopqrstuvwxyz";
			bool n;
			int i = 13;
			char[] a = new char[14];
			if (n = value < 0) {
				value = -value;
			}
			do {
				a[i--] = base36[(byte)(value % 36)];
			} while ((value /= 36) != 0);
			if (n) {
				a[i--] = '-';
			}
			return new string(a, i + 1, 13 - i);
		}
		public static string GenerateVerify() {
			const string base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			int i = 0;
			long t = (long)DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1)).TotalMilliseconds;
			char[] a = new char[36];
			Random r = new Random();
			do {
				switch (i) {
					case 8:
					case 13:
					case 18:
					case 23:
						a[i] = '_';
						break;
					case 14:
						a[i] = '4';
						break;
					default:
						a[i] = base62[r.Next(62)];
						break;
				}
				i++;
			} while (i < 36);
			return "verify_" + ToBase36(t) + "_" + new string(a);
		}
		public static string GenerateCookie() {
			string t = GenerateDeviceId();
			return "tt_webid=" + t + "; tt_webid_v2=" + t + "; tt_csrf_token=" + GenerateBase62(24) + "; s_v_web_id=" + GenerateVerify();
		}
		/*public static string GeneratePublicIp() {
			int i0, i1, i2;
			Random r = new Random();
			while ((i0 = r.Next(1, 224)) == 10 || i0 == 127) {}
			switch (i0) {
				case 100:
					while ((i1 = r.Next(256)) > 63 && i1 < 128) {}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 169:
					while ((i1 = r.Next(256)) == 254) {}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 172:
					while ((i1 = r.Next(256)) > 15 && i1 < 32) {}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 192:
					while ((i1 = r.Next(256)) == 168) {}
					switch (i1) {
						case 0:
							while ((i2 = r.Next(1, 256)) == 2) {}
							return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
						case 88:
							while ((i2 = r.Next(256)) == 99) {}
							return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
					}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 198:
					while ((i1 = r.Next(256)) == 18 || i1 == 19) {}
					if (i1 == 51) {
						while ((i2 = r.Next(256)) == 100) {}
						return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
					}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 203:
					if ((i1 = r.Next(256)) == 0) {
						while ((i2 = r.Next(256)) == 113) {}
						return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
					}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
			}
			return i0.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
		}*/
		/*public static string GenerateIp() {
			Random r = new Random();
			return r.Next(0, 256).ToString() + '.' + r.Next(0, 256).ToString() + '.' + r.Next(0, 256).ToString() + '.' + r.Next(0, 256).ToString();
		}*/
		public static string GetQualityUri(string value) {
			int i = value.IndexOf("?video_id="), e;
			if (i > -1 && (e = value.IndexOf("&", i + 10)) > -1) {
				return "https://api.tiktokv.com/aweme/v1/play/" + value.Substring(i, e - i) + "&improve_bitrate=1&ratio=default";
			}
			return value;
		}
		public static string GetQualityUri_(string value) {
			int i = value.IndexOf("?video_id="), e;
			if (i > -1 && (e = value.IndexOf("&", i + 10)) > -1) {
				return "https://api-h2.tiktokv.com/aweme/v1/play/" + value.Substring(i, e - i) + "&improve_bitrate=1&ratio=default";
			}
			return value;
		}
		public static bool ValidateId(string value) {
			if (value.Length == 0 || value.Length > 20 || value[0] < '1' || value[0] > '9') {
				return false;
			}
			for (int i = 1; i < value.Length; i++) {
				if (value[i] < '0' || value[i] > '9') {
					return false;
				}
			}
			return true;
		}
		public static string GetRedirect(string url) {
			int i = 0;
			string r = url;
			HttpWebRequest rq;
			HttpWebResponse rs;
			do {
				rq = (HttpWebRequest)HttpWebRequest.Create(url);
				rq.Method = "GET";
				rq.AllowAutoRedirect = false;
				rq.UserAgent = "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36";
				using (rs = (HttpWebResponse)rq.GetResponse()) {
					if ((int)rs.StatusCode < 300 || (int)rs.StatusCode >= 400) {
						break;
					} else if ((r = rs.Headers.Get("Location")) == null) {
						r = url;
						break;
					} else if (r.IndexOf("://") == -1) {
						r = (new Uri(new Uri(url), r)).ToString();
					}
				}
				url = r;
				i++;
			} while (i < 9);
			return r;
		}
		public static string ExtractId(string url) {
			int i = 0, e = 0;
			while (i < url.Length) {
				if (url[i] >= '1' && url[i] <= '9' && i > 1 && url[i - 1] == '/') {
					e = i;
					i++;
					while (i < url.Length && url[i] >= '0' && url[i] <= '9') {
						i++;
					}
					if (e + 1 < i) {
						return url.Substring(e, i - e);
					}
				}
				i++;
			}
			return null;
		}
		public static string[] GetIds(string value) {
			if (value.Length == 0) {
				return null;
			}
			int i = 0, e = 0, j;
			String t0, t1;
			StringBuilder b = new StringBuilder();
			List<String> r = new List<String>();
			do {
				while (i < value.Length && value[i] <= ' ') {
					i++;
				}
				if (i == value.Length) {
					break;
				} else if (value[i] < '1' || value[i] > '9') {
					j = i;
					i++;
					while (i < value.Length && value[i] > ' ') {
						i++;
					}
					if ((t1 = ExtractId(t0 = value.Substring(j, i - j))) != null) {
						b.Append(t1);
					} else {
						try {
							if ((t1 = GetRedirect(t0)) != null && t1.Length > 0 && t1 != t0 && (t1 = ExtractId(t1)) != null) {
								b.Append(t1);
							}
						} catch (Exception) {
							if (i == value.Length) {
								break;
							}
							i++;
							continue;
						}
					}
					if (i == value.Length) {
						break;
					}
				} else {
					b.Append(value[i]);
					i++;
					while (i < value.Length && value[i] >= '0' && value[i] <= '9') {
						b.Append(value[i]);
						i++;
					}
					if (i == value.Length) {
						break;
					} else if (value[i] > ' ' && (value[i] < '1' || value[i] > '9')) {
						return null;
					}
				}
				if (e == 29) {
					r.Add(b.ToString());
					b.Length = 0;
					e = 0;
				} else {
					b.Append(',');
					e++;
				}
				i++;
			} while (i < value.Length);
			if (b.Length > 0) {
				if (b[b.Length - 1] == ',') {
					b.Length = b.Length - 1;
				}
				r.Add(b.ToString());
			}
			return r.ToArray();
		}
		public string[] GetVideoUrlList(VideoData_ value) {
			if (Hevc) {
				if (value.PlayAddr265 != null && value.PlayAddr265.UrlList != null && value.PlayAddr265.UrlList.Length > 0) {
					return value.PlayAddr265.UrlList;
				} else if (value.PlayAddrBytevc1 != null && value.PlayAddrBytevc1.UrlList != null && value.PlayAddrBytevc1.UrlList.Length > 0) {
					return value.PlayAddrBytevc1.UrlList;
				}
			}
			if (value.PlayAddr != null && value.PlayAddr.UrlList != null && value.PlayAddr.UrlList.Length > 0) {
				return value.PlayAddr.UrlList;
			}
			return null;
		}
		public void DownloadAweme(object aweme) {
			Aweme a = (Aweme)aweme;
			try {
				bool f = false;
				int r = 0;
				string n, d = a.AddDate && a.Date > 0 ? CreateTimeToFilename(a.Date) : "", t = a.AddDescription && a.Description.Length > 0 ? SanitizeFilename(a.Description) : "";
				byte[] l;
				if (File.Exists(n = (d.Length > 0 ? a.Id + " " + d : a.Id) + (t.Length > 0 ? " " + t + ".mp4" : ".mp4"))) {
					return;
				}
				AwemeWebClient c = new AwemeWebClient();
				do {
					try {
						c.Headers.Set("User-Agent", "okhttp");
						c.DownloadFile(a.Url, n);
						if ((new FileInfo(n)).Length == 0) {
							File.Delete(n);
							throw new Exception("File is empty.");
						}
						break;
					} catch (PathTooLongException) {
						if (t.Length == 0 || f) {
							throw;
						} else if (File.Exists(n = (d.Length > 0 ? a.Id + " " + d : a.Id) + ".mp4")) {
							return;
						}
						f = true;
						r = 0;
					} catch (Exception) {
						if (r == 3) {
							File.Delete(n);
							throw;
						}
						r++;
					}
				} while (true);
				lock (OutLock) {
					Output.AppendText(a.Id);
					Output.AppendText(" is downloaded");
					Output.AppendText(Environment.NewLine);
					if (Logger != null) {
						l = Encoding.UTF8.GetBytes(a.Id + " " + CreateTimeToLog(a.Date) + " " + SanitizeLog(a.Description) + Environment.NewLine);
						Logger.Write(l, 0, l.Length);
					}
				}
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(a.Id);
					Output.AppendText(" failed");
					Output.AppendText(Environment.NewLine);
					Output.AppendText(x.InnerException != null ? x.InnerException.Message : x.Message);
					Output.AppendText(Environment.NewLine);
				}
			} finally {
				lock (SyncLock) {
					Count--;
					Monitor.Pulse(SyncLock);
				}
			}
		}
		public bool RequestAweme(WebClient client, DataContractJsonSerializer serializer, string path, out object result) {
			int r = 0;
			TimeSpan t;
			Stream s;
			Thread.Sleep(1000);
			do {
				lock (StopLock) {
					if (Stop) {
						break;
					}
				}
				t = DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1));
				try {
					client.Headers.Set("User-Agent", "okhttp");
					/*if (Ip.Length > 0) {
						client.Headers.Set("X-Forwarded-For", Ip);
					}*/
					using (s = client.OpenRead("https://api-t2.tiktokv.com" + path
					+ "&region=US"
					//+ "&version_name=10.0.0"
					+ "&ts=" + ((int)t.TotalSeconds).ToString()
					+ "&timezone_name=Etc%2FGMT"
					+ "&device_type=Pixel%20" + DeviceVersion
					+ "&iid=" + IId
					+ "&locale=en"
					+ "&app_type=normal"
					//+ "&build_number=10.0.0"
					+ "&resolution=1080*1920"
					+ "&aid=1180"
					+ "&app_name=musical_ly"
					+ "&_rticket=" + ((long)t.TotalMilliseconds).ToString()
					+ "&device_platform=android"
					+ "&version_code=100000"
					+ "&dpi=441"
					+ "&cpu_support64=false"
					+ "&sys_region=US"
					+ "&timezone_offset=0"
					+ "&device_id=" + DeviceId
					+ "&pass-route=1"
					+ "&device_brand=google"
					+ "&os_version=8.0.0"
					//+ "&ab_version=10.0.0"
					+ "&op_region=US"
					+ "&app_language=en"
					+ "&pass-region=1"
					+ "&language=en"
					+ "&channel=googleplay"
					+ (Hevc ? "&version_name=10.0.0&build_number=10.0.0" : ""))) {
						result = serializer.ReadObject(s);
						return true;
					}
				} catch {
					//Os = GenerateBase62(16);
					//Ip = GeneratePublicIp();
					DeviceId = GenerateDeviceId();
					IId = GenerateDeviceId();
					DeviceVersion = GenerateBase62(8);
					if (r == 32) {//SerializationException or else
						//Ip = "";
						throw;
					}
					r++;
				}
			} while (true);
			result = null;
			return false;
		}
		public bool RequestTiktok(WebClient client, DataContractJsonSerializer serializer, string path, out object result) {
			int r = 0;
			Stream s;
			//Thread.Sleep(1000);
			do {
				lock (StopLock) {
					if (Stop) {
						break;
					}
				}
				try {
					client.Headers.Set("User-Agent", "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36");
					client.Headers.Set("Referer", "https://www.tiktok.com/");
					client.Headers.Set("Cookie", Cookie);
					using (s = client.OpenRead("https://www.tiktok.com" + path)) {
						result = serializer.ReadObject(s);
						return true;
					}
				} catch {
					//Cookie = GenerateCookie();
					if (r == 9) {//SerializationException or else
						throw;
					}
					r++;
				}
			} while (true);
			result = null;
			return false;
		}
		public bool InfoUserId(string id, out UserInfoData result) {
			int i, e;
			string t;
			object r;
			UserInfoResponse o;
			if ((t = GetRedirect("https://www.tiktok.com/share/user/" + id)) == null || (i = t.IndexOf("/@")) == -1) {
				result = null;
				return true;
			}
			i += 2;
			t = (e = t.IndexOf('?', i)) == -1 && (e = t.IndexOf('/', i)) == -1 ? t.Substring(i) : t.Substring(i, e - i);
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(UserInfoResponse)), "/node/share/user/@" + t + "?user_agent=", out r)) {
				result = null;
				return false;
			}
			result = (o = (UserInfoResponse)r) != null ? o.UserInfo : null;
			return true;
		}
		public bool InfoUserName(string name, out UserInfoData result) {
			object r;
			UserInfoResponse o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(UserInfoResponse)), "/node/share/user/@" + Uri.EscapeUriString(name) + "?user_agent=", out r)) {
				result = null;
				return false;
			}
			result = (o = (UserInfoResponse)r) != null ? o.UserInfo : null;
			return true;
		}
		public bool InfoMusicId(string id, out MusicInfoData result) {
			object r;
			MusicInfoResponse o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(MusicInfoResponse)), "/node/share/music/_-" + id + "?user_agent=", out r)) {
				result = null;
				return false;
			}
			result = (o = (MusicInfoResponse)r) != null ? o.MusicInfo : null;
			return true;
		}
		public bool InfoChallengeId(string id, out ChallengeInfoData result) {
			int i, e;
			string t;
			object r;
			ChallengeInfoResponse o;
			if ((t = GetRedirect("https://www.tiktok.com/share/challenge/" + id)) == null || (i = t.IndexOf("/tag/")) == -1) {
				result = null;
				return true;
			}
			i += 5;
			t = (e = t.IndexOf('?', i)) == -1 && (e = t.IndexOf('/', i)) == -1 ? t.Substring(i) : t.Substring(i, e - i);
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(ChallengeInfoResponse)), "/node/share/tag/" + t + "?user_agent=", out r)) {
				result = null;
				return false;
			}
			result = (o = (ChallengeInfoResponse)r) != null ? o.ChallengeInfo : null;
			return true;
		}
		public bool InfoChallengeTag(string tag, out ChallengeInfoData result) {
			object r;
			ChallengeInfoResponse o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(ChallengeInfoResponse)), "/node/share/tag/" + Uri.EscapeUriString(tag) + "?user_agent=", out r)) {
				result = null;
				return false;
			}
			result = (o = (ChallengeInfoResponse)r) != null ? o.ChallengeInfo : null;
			return true;
		}
		public bool InfoVideoId(string id, out ItemInfoData result) {
			object r;
			VideoInfoResponse o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(VideoInfoResponse)), "/node/share/video/@_/" + id + "?user_agent=", out r)) {
				result = null;
				return false;
			}
			result = (o = (VideoInfoResponse)r) != null ? o.ItemInfo : null;
			return true;
		}
		public bool InfoAweme(string id, out AwemeDetailData result) {
			object r;
			AwemeData o;
			if (!RequestAweme(new WebClient(), new DataContractJsonSerializer(typeof(AwemeData)), "/aweme/v1/aweme/detail/?aweme_id=" + id, out r)) {
				result = null;
				return false;
			}
			result = (o = (AwemeData)r) != null ? o.AwemeDetail : null;
			return true;
		}
		public void OutputUserInfo(UserInfoData user) {
			if (user.User.Id == null) {
				return;
			}
			Output.AppendText("id: ");
			Output.AppendText(user.User.Id);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("unique id: ");
			Output.AppendText(user.User.UniqueId);
			Output.AppendText(Environment.NewLine);
			if (user.User.SecUid != null && user.User.SecUid.Length > 0) {
				Output.AppendText("secure id: ");
				Output.AppendText(user.User.SecUid);
				Output.AppendText(Environment.NewLine);
			}
			Output.AppendText("nickname: ");
			Output.AppendText(user.User.Nickname);
			Output.AppendText(Environment.NewLine);
			if (user.User.CreateTime != 0) {
				Output.AppendText("created: ");
				Output.AppendText(CreateTimeToString(user.User.CreateTime));
				Output.AppendText(Environment.NewLine);
			}
			Output.AppendText("verified: ");
			Output.AppendText(user.User.Verified ? "yes" : "no");
			Output.AppendText(Environment.NewLine);
			Output.AppendText("private: ");
			Output.AppendText(user.User.Secret ? "yes" : "no");
			Output.AppendText(Environment.NewLine);
			Output.AppendText("likes: ");
			Output.AppendText(user.User.OpenFavorite ? "yes" : "no");
			Output.AppendText(Environment.NewLine);
			Output.AppendText("videos: ");
			Output.AppendText(user.Stats.VideoCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("favorites: ");
			Output.AppendText(user.Stats.DiggCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("favorited: ");
			Output.AppendText(user.Stats.HeartCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("followings: ");
			Output.AppendText(user.Stats.FollowingCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("followers: ");
			Output.AppendText(user.Stats.FollowerCount.ToString());
			Output.AppendText(Environment.NewLine);
			if (user.User.AvatarLarger != null && user.User.AvatarLarger.Length > 0) {
				Output.AppendText("avatar: ");
				Output.AppendText(user.User.AvatarLarger);
				Output.AppendText(Environment.NewLine);
			}
			if (user.User.Signature != null && user.User.Signature.Length > 0) {
				Output.AppendText(ReplaceNewlines(user.User.Signature, Environment.NewLine));
				Output.AppendText(Environment.NewLine);
			}
			if (user.User.BioLink != null && user.User.BioLink.Link != null && user.User.BioLink.Link.Length > 0) {
				Output.AppendText(user.User.BioLink.Link);
				Output.AppendText(Environment.NewLine);
			}
		}
		public void OutputMusicInfo(MusicInfoData music) {
			if (music.Music.Id == null) {
				return;
			}
			Output.AppendText("id: ");
			Output.AppendText(music.Music.Id);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("title: ");
			Output.AppendText(music.Music.Title);
			Output.AppendText(Environment.NewLine);
			if (music.Music.AuthorName != null && music.Music.AuthorName.Length > 0) {
				Output.AppendText("author: ");
				Output.AppendText(music.Music.AuthorName);
				Output.AppendText(Environment.NewLine);
			}
			Output.AppendText("videos: ");
			Output.AppendText(music.Stats.VideoCount.ToString());
			Output.AppendText(Environment.NewLine);
			if (music.Music.CoverLarge != null && music.Music.CoverLarge.Length > 0) {
				Output.AppendText("cover: ");
				Output.AppendText(music.Music.CoverLarge);
				Output.AppendText(Environment.NewLine);
			}
			if (music.Music.PlayUrl != null && music.Music.PlayUrl.Length > 0) {
				Output.AppendText("play: ");
				Output.AppendText(music.Music.PlayUrl);
				Output.AppendText(Environment.NewLine);
			}
			if (music.Author != null && music.Author.Id != null) {
				Output.AppendText("user id: ");
				Output.AppendText(music.Author.Id);
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user unique id: ");
				Output.AppendText(music.Author.UniqueId);
				Output.AppendText(Environment.NewLine);
				if (music.Author.SecUid != null && music.Author.SecUid.Length > 0) {
					Output.AppendText("user secure id: ");
					Output.AppendText(music.Author.SecUid);
					Output.AppendText(Environment.NewLine);
				}
				Output.AppendText("user nickname: ");
				Output.AppendText(music.Author.Nickname);
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user verified: ");
				Output.AppendText(music.Author.Verified ? "yes" : "no");
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user private: ");
				Output.AppendText(music.Author.Secret ? "yes" : "no");
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user likes: ");
				Output.AppendText(music.Author.OpenFavorite ? "yes" : "no");
				Output.AppendText(Environment.NewLine);
				if (music.Author.AvatarLarger != null && music.Author.AvatarLarger.Length > 0) {
					Output.AppendText("user avatar: ");
					Output.AppendText(music.Author.AvatarLarger);
					Output.AppendText(Environment.NewLine);
				}
				if (music.Author.Signature != null && music.Author.Signature.Length > 0) {
					Output.AppendText(ReplaceNewlines(music.Author.Signature, Environment.NewLine));
					Output.AppendText(Environment.NewLine);
				}
			}
		}
		public void OutputChallengeInfo(ChallengeInfoData challenge) {
			if (challenge.Challenge.Id == null) {
				return;
			}
			Output.AppendText("id: ");
			Output.AppendText(challenge.Challenge.Id);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("tag: ");
			Output.AppendText(challenge.Challenge.Title);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("videos: ");
			Output.AppendText(challenge.Stats.VideoCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("views: ");
			Output.AppendText(challenge.Stats.ViewCount.ToString());
			Output.AppendText(Environment.NewLine);
			if (challenge.Challenge.ProfileLarger != null && challenge.Challenge.ProfileLarger.Length > 0) {
				Output.AppendText("cover: ");
				Output.AppendText(challenge.Challenge.ProfileLarger);
				Output.AppendText(Environment.NewLine);
			}
			if (challenge.Challenge.Desc != null && challenge.Challenge.Desc.Length > 0) {
				Output.AppendText(ReplaceNewlines(challenge.Challenge.Desc, Environment.NewLine));
				Output.AppendText(Environment.NewLine);
			}
		}
		public void OutputVideoInfo(ItemInfoData video) {
			if (video.ItemStruct.Id == null) {
				return;
			}
			string[] u;
			AwemeDetailData a;
			Output.AppendText("id: ");
			Output.AppendText(video.ItemStruct.Id);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("created: ");
			Output.AppendText(CreateTimeToString(video.ItemStruct.CreateTime));
			Output.AppendText(Environment.NewLine);
			if (video.ItemStruct.Stats != null) {
				Output.AppendText("views: ");
				Output.AppendText(video.ItemStruct.Stats.PlayCount.ToString());
				Output.AppendText(Environment.NewLine);
				Output.AppendText("likes: ");
				Output.AppendText(video.ItemStruct.Stats.DiggCount.ToString());
				Output.AppendText(Environment.NewLine);
				Output.AppendText("comments: ");
				Output.AppendText(video.ItemStruct.Stats.CommentCount.ToString());
				Output.AppendText(Environment.NewLine);
				Output.AppendText("shares: ");
				Output.AppendText(video.ItemStruct.Stats.ShareCount.ToString());
				Output.AppendText(Environment.NewLine);
			}
			if (video.ItemStruct.Video.Cover != null && video.ItemStruct.Video.Cover.Length > 0) {
				Output.AppendText("cover: ");
				Output.AppendText(video.ItemStruct.Video.Cover);
				Output.AppendText(Environment.NewLine);
			}
			if (video.ItemStruct.Video.DynamicCover != null && video.ItemStruct.Video.DynamicCover.Length > 0) {
				Output.AppendText("dynamic cover: ");
				Output.AppendText(video.ItemStruct.Video.DynamicCover);
				Output.AppendText(Environment.NewLine);
			}
			if (video.ItemStruct.Video.PlayAddr != null) {
				Output.AppendText("play: ");
				try {
					Output.AppendText(InfoAweme(video.ItemStruct.Id, out a) && a != null && a.Video != null && (u = GetVideoUrlList(a.Video)) != null ? Quality ? GetQualityUri_(u[u.Length - 1]) : u[0] : video.ItemStruct.Video.PlayAddr);
				} catch {
					Output.AppendText(video.ItemStruct.Video.PlayAddr);
				}
			}
			Output.AppendText(Environment.NewLine);
			if (video.ItemStruct.Desc != null && video.ItemStruct.Desc.Length > 0) {
				Output.AppendText(ReplaceNewlines(video.ItemStruct.Desc, Environment.NewLine));
				Output.AppendText(Environment.NewLine);
			}
			if (video.ItemStruct.Music != null && video.ItemStruct.Music.Id != null) {
				Output.AppendText("music id: ");
				Output.AppendText(video.ItemStruct.Music.Id);
				Output.AppendText(Environment.NewLine);
				Output.AppendText("music title: ");
				Output.AppendText(video.ItemStruct.Music.Title);
				Output.AppendText(Environment.NewLine);
				if (video.ItemStruct.Music.AuthorName != null && video.ItemStruct.Music.AuthorName.Length > 0) {
					Output.AppendText("music author: ");
					Output.AppendText(video.ItemStruct.Music.AuthorName);
					Output.AppendText(Environment.NewLine);
				}
				if (video.ItemStruct.Music.CoverLarge != null && video.ItemStruct.Music.CoverLarge.Length > 0) {
					Output.AppendText("music cover: ");
					Output.AppendText(video.ItemStruct.Music.CoverLarge);
					Output.AppendText(Environment.NewLine);
				}
				if (video.ItemStruct.Music.PlayUrl != null && video.ItemStruct.Music.PlayUrl.Length > 0) {
					Output.AppendText("music play: ");
					Output.AppendText(video.ItemStruct.Music.PlayUrl);
					Output.AppendText(Environment.NewLine);
				}
			}
			if (video.ItemStruct.Author != null && video.ItemStruct.Author.Id != null) {
				Output.AppendText("user id: ");
				Output.AppendText(video.ItemStruct.Author.Id);
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user unique id: ");
				Output.AppendText(video.ItemStruct.Author.UniqueId);
				Output.AppendText(Environment.NewLine);
				if (video.ItemStruct.Author.SecUid != null && video.ItemStruct.Author.SecUid.Length > 0) {
					Output.AppendText("user secure id: ");
					Output.AppendText(video.ItemStruct.Author.SecUid);
					Output.AppendText(Environment.NewLine);
				}
				Output.AppendText("user nickname: ");
				Output.AppendText(video.ItemStruct.Author.Nickname);
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user verified: ");
				Output.AppendText(video.ItemStruct.Author.Verified ? "yes" : "no");
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user private: ");
				Output.AppendText(video.ItemStruct.Author.Secret ? "yes" : "no");
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user likes: ");
				Output.AppendText(video.ItemStruct.Author.OpenFavorite ? "yes" : "no");
				Output.AppendText(Environment.NewLine);
				if (video.ItemStruct.AuthorStats != null) {
					Output.AppendText("user videos: ");
					Output.AppendText(video.ItemStruct.AuthorStats.VideoCount.ToString());
					Output.AppendText(Environment.NewLine);
					Output.AppendText("user favorites: ");
					Output.AppendText(video.ItemStruct.AuthorStats.DiggCount.ToString());
					Output.AppendText(Environment.NewLine);
					Output.AppendText("user favorited: ");
					Output.AppendText(video.ItemStruct.AuthorStats.HeartCount.ToString());
					Output.AppendText(Environment.NewLine);
					Output.AppendText("user followings: ");
					Output.AppendText(video.ItemStruct.AuthorStats.FollowingCount.ToString());
					Output.AppendText(Environment.NewLine);
					Output.AppendText("user followers: ");
					Output.AppendText(video.ItemStruct.AuthorStats.FollowerCount.ToString());
					Output.AppendText(Environment.NewLine);
				}
				if (video.ItemStruct.Author.AvatarLarger != null && video.ItemStruct.Author.AvatarLarger.Length > 0) {
					Output.AppendText("user avatar: ");
					Output.AppendText(video.ItemStruct.Author.AvatarLarger);
					Output.AppendText(Environment.NewLine);
				}
				if (video.ItemStruct.Author.Signature != null && video.ItemStruct.Author.Signature.Length > 0) {
					Output.AppendText(ReplaceNewlines(video.ItemStruct.Author.Signature, Environment.NewLine));
					Output.AppendText(Environment.NewLine);
				}
			}
		}
		public bool DownloadAwemes(WebClient client, Download download, string ids) {
			string[] u;
			object r;
			AwemesData o;
			if (!RequestAweme(client, new DataContractJsonSerializer(typeof(AwemesData)), "/aweme/v1/multi/aweme/detail/?aweme_ids=[" + ids + "]", out r)) {
				return false;
			}
			o = (AwemesData)r;
			if (o != null && o.AwemeDetails != null) {
				for (int i = 0; i < o.AwemeDetails.Length; i++) {
					if (o.AwemeDetails[i].Video != null && (u = GetVideoUrlList(o.AwemeDetails[i].Video)) != null) {
						lock (SyncLock) {
							Count++;
						}
						new Thread(new ParameterizedThreadStart(DownloadAweme)).Start(new Aweme {
							Id = o.AwemeDetails[i].AwemeId,
							Date = o.AwemeDetails[i].CreateTime,
							Description = o.AwemeDetails[i].Desc != null ? o.AwemeDetails[i].Desc : "",
							Url = Quality ? GetQualityUri(u[u.Length - 1]) : u[0],
							AddDate = Date,
							AddDescription = Description
						});
						lock (SyncLock) {
							if (Count >= 10) {
								Monitor.Wait(SyncLock);
							}
						}
					}
				}
			}
			return true;
		}
		public void InfoUser(object idOrName) {
			try {
				string i = (string)idOrName;
				UserInfoData ui;
				if (!(i[0] == '@' ? InfoUserName(i.Substring(1), out ui) : InfoUserId(i, out ui))) {
					goto end;
				} else if (ui == null || ui.User == null) {
					throw new Exception("Data is null.");
				}
				OutputUserInfo(ui);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: EnableControls();
		}
		public void InfoMusic(object id) {
			try {
				MusicInfoData mi;
				if (!InfoMusicId((string)id, out mi)) {
					goto end;
				} else if (mi == null || mi.Music == null) {
					throw new Exception("Data is null.");
				}
				OutputMusicInfo(mi);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: EnableControls();
		}
		public void InfoChallenge(object idOrTag) {
			try {
				string i = (string)idOrTag;
				ChallengeInfoData ci;
				if (!(i[0] == '#' ? InfoChallengeTag(i.Substring(1), out ci) : InfoChallengeId(i, out ci))) {
					goto end;
				} else if (ci == null || ci.Challenge == null) {
					throw new Exception("Data is null.");
				}
				OutputChallengeInfo(ci);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: EnableControls();
		}
		public void InfoVideo(object id) {
			try {
				ItemInfoData ii;
				if (!InfoVideoId((string)id, out ii)) {
					goto end;
				} else if (ii == null || ii.ItemStruct == null || ii.ItemStruct.Video == null) {
					throw new Exception("Data is null.");
				}
				OutputVideoInfo(ii);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: EnableControls();
		}
		public void DownloadUserVideos(object download) {
			string cu = "0";
			try {
				Download d = (Download)download;
				cu = d.Cursor.ToString();
				long i = 0, e = 0, j;
				object r;
				StringBuilder b = new StringBuilder();
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(VideosResponse));
				VideosResponse o;
				UserInfoData ui;
				if (d.Id[0] == '@') {
					if (!InfoUserName(d.Id.Substring(1), out ui)) {
						goto end;
					} else if (ui == null || ui.User == null || ui.User.Secret) {
						throw new Exception("Data is null.");
					}
					d.Id = ui.User.Id;
				}
				do {
					if (!RequestTiktok(c, js, "/node/video/feed"
					+ "?secUid="
					+ "&id=" + d.Id
					+ "&type=1"
					+ "&count=30"
					+ "&minCursor=0"
					+ "&maxCursor=" + cu
					+ "&shareUid="
					+ "&lang=en", out r)) {
						break;
					}
					o = (VideosResponse)r;
					if (o == null || o.Body == null || o.Body.MaxCursor == null) {
						lock (OutLock) {
							Output.AppendText("Data is null.");
							Output.AppendText(Environment.NewLine);
						}
						break;
					} else if (o.Body.ItemListData != null) {
						for (i = 0; i < o.Body.ItemListData.Length; i++, e++) {
							if (d.IsMax) {
								if (e == d.Limit) {
									o.Body.HasMore = false;
									break;
								}
							}
							if (o.Body.ItemListData[i].ItemInfos != null) {
								if (!d.IsMax && o.Body.ItemListData[i].ItemInfos.CreateTime != null && Int64.TryParse(o.Body.ItemListData[i].ItemInfos.CreateTime, NumberStyles.None, CultureInfo.InvariantCulture, out j) && j < d.Limit) {
									o.Body.HasMore = false;
									break;
								}
								if (b.Length > 0) {
									b.Append(',');
								}
								b.Append(o.Body.ItemListData[i].ItemInfos.Id);
							}
						}
						if (b.Length > 0) {
							if (!DownloadAwemes(c, d, b.ToString())) {
								break;
							}
							b.Length = 0;
						}
					}
					if (!o.Body.HasMore) {
						break;
					}
					cu = o.Body.MaxCursor;
				} while (true);
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(x.Message);
					Output.AppendText(Environment.NewLine);
				}
			}
			do {
				lock (SyncLock) {
					if (Count == 0) {
						break;
					}
					Monitor.Wait(SyncLock);
				}
			} while (true);
			end: Output.AppendText("cursor is ");
			Output.AppendText(cu.ToString());
			Output.AppendText(Environment.NewLine);
			EnableControls();
		}
		public void DownloadMusicVideos(object download) {
			string cu = "0";
			try {
				Download d = (Download)download;
				cu = d.Cursor.ToString();
				long i = 0, e = 0;
				object r;
				StringBuilder b = new StringBuilder();
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(VideosResponse));
				VideosResponse o;
				do {
					if (!RequestTiktok(c, js, "/node/video/feed"
					+ "?secUid="
					+ "&id=" + d.Id
					+ "&type=4"
					+ "&count=30"
					+ "&minCursor=0"
					+ "&maxCursor=" + cu
					+ "&shareUid="
					+ "&lang=en", out r)) {
						break;
					}
					o = (VideosResponse)r;
					if (o == null || o.Body == null || o.Body.MaxCursor == null) {
						lock (OutLock) {
							Output.AppendText("Data is null.");
							Output.AppendText(Environment.NewLine);
						}
						break;
					} else if (o.Body.ItemListData != null) {
						for (i = 0; i < o.Body.ItemListData.Length; i++, e++) {
							if (e == d.Limit) {
								o.Body.HasMore = false;
								break;
							} else if (o.Body.ItemListData[i].ItemInfos != null) {
								if (b.Length > 0) {
									b.Append(',');
								}
								b.Append(o.Body.ItemListData[i].ItemInfos.Id);
							}
						}
						if (b.Length > 0) {
							if (!DownloadAwemes(c, d, b.ToString())) {
								break;
							}
							b.Length = 0;
						}
					}
					if (!o.Body.HasMore) {
						break;
					}
					cu = o.Body.MaxCursor;
				} while (true);
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(x.Message);
					Output.AppendText(Environment.NewLine);
				}
			}
			do {
				lock (SyncLock) {
					if (Count == 0) {
						break;
					}
					Monitor.Wait(SyncLock);
				}
			} while (true);
			Output.AppendText("cursor is ");
			Output.AppendText(cu.ToString());
			Output.AppendText(Environment.NewLine);
			EnableControls();
		}
		public void DownloadChallengeVideos(object download) {
			string cu = "0";
			try {
				Download d = (Download)download;
				cu = d.Cursor.ToString();
				long i = 0, e = 0;
				object r;
				StringBuilder b = new StringBuilder();
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(VideosResponse));
				VideosResponse o;
				ChallengeInfoData ci;
				if (d.Id[0] == '#') {
					if (!InfoChallengeTag(d.Id.Substring(1), out ci)) {
						goto end;
					} else if (ci == null || ci.Challenge == null) {
						throw new Exception("Data is null.");
					}
					d.Id = ci.Challenge.Id;
				}
				do {
					if (!RequestTiktok(c, js, "/node/video/feed"
					+ "?secUid="
					+ "&id=" + d.Id
					+ "&type=3"
					+ "&count=30"
					+ "&minCursor=0"
					+ "&maxCursor=" + cu
					+ "&shareUid="
					+ "&lang=en", out r)) {
						break;
					}
					o = (VideosResponse)r;
					if (o == null || o.Body == null || o.Body.MaxCursor == null) {
						lock (OutLock) {
							Output.AppendText("Data is null.");
							Output.AppendText(Environment.NewLine);
						}
						break;
					} else if (o.Body.ItemListData != null) {
						for (i = 0; i < o.Body.ItemListData.Length; i++, e++) {
							if (e == d.Limit) {
								o.Body.HasMore = false;
								break;
							} else if (o.Body.ItemListData[i].ItemInfos != null) {
								if (b.Length > 0) {
									b.Append(',');
								}
								b.Append(o.Body.ItemListData[i].ItemInfos.Id);
							}
						}
						if (b.Length > 0) {
							if (!DownloadAwemes(c, d, b.ToString())) {
								break;
							}
							b.Length = 0;
						}
					}
					if (!o.Body.HasMore) {
						break;
					}
					cu = o.Body.MaxCursor;
				} while (true);
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(x.Message);
					Output.AppendText(Environment.NewLine);
				}
			}
			do {
				lock (SyncLock) {
					if (Count == 0) {
						break;
					}
					Monitor.Wait(SyncLock);
				}
			} while (true);
			end: Output.AppendText("cursor is ");
			Output.AppendText(cu.ToString());
			Output.AppendText(Environment.NewLine);
			EnableControls();
		}
		public void DownloadVideos(object download) {
			try {
				Download d = (Download)download;
				long i = 0, e = 0, j = 0;
				string[] v, u;
				object r;
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(AwemesData));
				AwemesData o;
				if (ValidateId(d.Id)) {
					v = new string[] {d.Id};
				} else if ((v = GetIds(File.ReadAllText(Path.IsPathRooted(d.Id) ? d.Id : Root + Path.DirectorySeparatorChar + d.Id, Encoding.UTF8))) == null || v.Length == 0) {
					goto end;
				}
				do {
					if (!RequestAweme(c, js, "/aweme/v1/multi/aweme/detail/?aweme_ids=[" + v[j] + "]", out r)) {
						break;
					}
					o = (AwemesData)r;
					if (o != null && o.AwemeDetails != null) {
						for (i = 0; i < o.AwemeDetails.Length; i++, e++) {
							if (e == d.Limit) {
								j = v.Length - 1;
								break;
							} else if (o.AwemeDetails[i].Video != null && (u = GetVideoUrlList(o.AwemeDetails[i].Video)) != null) {
								lock (SyncLock) {
									Count++;
								}
								new Thread(new ParameterizedThreadStart(DownloadAweme)).Start(new Aweme {
									Id = o.AwemeDetails[i].AwemeId,
									Date = o.AwemeDetails[i].CreateTime,
									Description = o.AwemeDetails[i].Desc != null ? o.AwemeDetails[i].Desc : "",
									Url = Quality ? GetQualityUri(u[u.Length - 1]) : u[0],
									AddDate = Date,
									AddDescription = Description
								});
								lock (SyncLock) {
									if (Count >= 10) {
										Monitor.Wait(SyncLock);
									}
								}
							}
						}
					}
					j++;
				} while (j < v.Length);
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(x.Message);
					Output.AppendText(Environment.NewLine);
				}
			}
			do {
				lock (SyncLock) {
					if (Count == 0) {
						break;
					}
					Monitor.Wait(SyncLock);
				}
			} while (true);
			end: EnableControls();
		}
		public void AddDateChanged(object sender, EventArgs args) {
			Date = AddDate.Checked;
		}
		public void AddDescriptionChanged(object sender, EventArgs args) {
			Description = AddDescription.Checked;
		}
		public void ImproveQualityChanged(object sender, EventArgs args) {
			Quality = ImproveQuality.Checked;
		}
		public void PreferHevcChanged(object sender, EventArgs args) {
			Hevc = PreferHevc.Checked;
		}
		public void DirLeave(object sender, EventArgs args) {
			try {
				string d0 = GetFullDir(Dir, Root), d1 = GetFullDir(DirInput.Text, Root);
				if (d0 != d1) {
					if (!Directory.Exists(d1)) {
						Directory.CreateDirectory(d1);
					}
					Directory.SetCurrentDirectory(d1);
					Dir = DirInput.Text;
				}
			} catch (Exception x) {
				MessageBox.Show(x.Message);
				DirInput.Text = Dir;
			}
		}
		public void OpenDirClick(object sender, EventArgs args) {
			if (DirOpener.ShowDialog() != DialogResult.OK) {
				return;
			}
			DirInput.Text = DirOpener.SelectedPath;
			DirLeave(DirInput, null);
		}
		public void CookieLeave(object sender, EventArgs args) {
			Cookie = CookieInput.Text;
		}
		public void TypeSelectedIndexChanged(object sender, EventArgs args) {
			switch (TypeInput.SelectedIndex) {
				case 0:
					IdLabel.Text = "id/name:";
					Tip.SetToolTip(IdInput, "id/name (id or @name) - id or name of a user");
					LimitLabel.Text = "date/max:";
					Tip.SetToolTip(LimitInput, "date/max (optional - YYYY-MM-DD or integer) - date until which to check videos or max number of videos to check");
					CursorInput.ReadOnly = false;
					Tip.SetToolTip(CursorInput, "cursor (integer) - unix time in milliseconds");
					if (OpenFile.Visible) {
						IdInput.Width = IdInput.Width + 26;
						OpenFile.Visible = false;
					}
					break;
				case 1:
					IdLabel.Text = "id:";
					Tip.SetToolTip(IdInput, "id (id) - id of a music");
					LimitLabel.Text = "max:";
					Tip.SetToolTip(LimitInput, "max (optional - integer) - max number of videos to check");
					CursorInput.ReadOnly = false;
					Tip.SetToolTip(CursorInput, "cursor (integer) - video offset");
					if (OpenFile.Visible) {
						IdInput.Width = IdInput.Width + 26;
						OpenFile.Visible = false;
					}
					break;
				case 2:
					IdLabel.Text = "id/tag:";
					Tip.SetToolTip(IdInput, "id/tag (id or #tag) - id or tag of a hashtag");
					LimitLabel.Text = "max:";
					Tip.SetToolTip(LimitInput, "max (optional - integer) - max number of videos to check");
					CursorInput.ReadOnly = false;
					Tip.SetToolTip(CursorInput, "cursor (integer) - video offset");
					if (OpenFile.Visible) {
						IdInput.Width = IdInput.Width + 26;
						OpenFile.Visible = false;
					}
					break;
				default://3
					IdLabel.Text = "id/file:";
					Tip.SetToolTip(IdInput, "id/file (id or file) - id of a video or file with ids or urls of videos (separated by whitespace)");
					LimitLabel.Text = "max:";
					Tip.SetToolTip(LimitInput, "max (optional - integer) - max number of videos to check");
					CursorInput.ReadOnly = true;
					Tip.SetToolTip(CursorInput, "cursor (integer)");
					if (!OpenFile.Visible) {
						IdInput.Width = IdInput.Width - 26;
						OpenFile.Visible = true;
					}
					break;
			}
		}
		public void OpenFileClick(object sender, EventArgs args) {
			if (TypeInput.SelectedIndex != 3 || FileOpener.ShowDialog() != DialogResult.OK) {
				return;
			}
			IdInput.Text = FileOpener.FileName;
		}
		public void InfoClick(object sender, EventArgs args) {
			lock (StopLock) {
				Stop = true;
				if (IdInput.ReadOnly) {
					return;
				}
			}
			DisableControls();
			switch (TypeInput.SelectedIndex) {
				case 0:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id or name is empty.");
						goto end;
					} else if (IdInput.Text[0] == '@') {
						if (IdInput.Text.Length == 1) {
							MessageBox.Show("Name is empty.");
							goto end;
						}
					} else if (!ValidateId(IdInput.Text)) {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(InfoUser)).Start(IdInput.Text);
					return;
				case 1:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id is empty.");
						goto end;
					} else if (!ValidateId(IdInput.Text)) {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(InfoMusic)).Start(IdInput.Text);
					return;
				case 2:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id or tag is empty.");
						goto end;
					} else if (IdInput.Text[0] == '#') {
						if (IdInput.Text.Length == 1) {
							MessageBox.Show("Tag is empty.");
							goto end;
						}
					} else if (!ValidateId(IdInput.Text)) {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(InfoChallenge)).Start(IdInput.Text);
					return;
				default://3
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id is empty.");
						goto end;
					} else if (!ValidateId(IdInput.Text)) {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(InfoVideo)).Start(IdInput.Text);
					return;
			}
			end: EnableControls();
		}
		public void DownloadClick(object sender, EventArgs args) {
			lock (StopLock) {
				Stop = true;
				if (IdInput.ReadOnly) {
					return;
				}
			}
			DisableControls();
			if (Log.Checked) {
				try {
					Logger = new FileStream("log.txt", FileMode.Append);
				} catch (Exception x) {
					MessageBox.Show(x.Message);
					goto end;
				}
			}
			long l, c;
			switch (TypeInput.SelectedIndex) {
				case 0:
					bool im;
					DateTime d;
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id or name is empty.");
						goto end;
					} else if (IdInput.Text[0] == '@') {
						if (IdInput.Text.Length == 1) {
							MessageBox.Show("Name is empty.");
							goto end;
						} else if (LimitInput.Text.Length == 0) {
							im = true;
							l = -1;
						} else if (DateTime.TryParseExact(LimitInput.Text, "yyyy-MM-dd", CultureInfo.InvariantCulture, DateTimeStyles.None, out d)) {
							im = false;
							l = (long)d.Subtract(new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).TotalSeconds;
						} else if (Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							im = true;
						} else {
							MessageBox.Show("Date or max is not valid.");
							goto end;
						}
					} else if (ValidateId(IdInput.Text)) {
						if (LimitInput.Text.Length == 0) {
							im = true;
							l = -1;
						} else if (DateTime.TryParseExact(LimitInput.Text, "yyyy-MM-dd", CultureInfo.InvariantCulture, DateTimeStyles.None, out d)) {
							im = false;
							l = (long)d.Subtract(new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).TotalSeconds;
						} else if (Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							im = true;
						} else {
							MessageBox.Show("Date or max is not valid.");
							goto end;
						}
					} else {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					if (!Int64.TryParse(CursorInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out c)) {
						MessageBox.Show("Cursor is not valid integer.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(DownloadUserVideos)).Start(new Download {
						Id = IdInput.Text,
						Limit = l,
						IsMax = im,
						Cursor = c
					});
					return;
				case 1:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id is empty.");
						goto end;
					} else if (ValidateId(IdInput.Text)) {
						if (LimitInput.Text.Length == 0) {
							l = -1;
						} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							MessageBox.Show("Max is not valid.");
							goto end;
						}
					} else {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					if (!Int64.TryParse(CursorInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out c)) {
						MessageBox.Show("Cursor is not valid integer.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(DownloadMusicVideos)).Start(new Download {
						Id = IdInput.Text,
						Limit = l,
						IsMax = true,
						Cursor = c
					});
					return;
				case 2:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id or tag is empty.");
						goto end;
					} else if (IdInput.Text[0] == '#') {
						if (IdInput.Text.Length == 1) {
							MessageBox.Show("Tag is empty.");
							goto end;
						} else if (LimitInput.Text.Length == 0) {
							l = -1;
						} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							MessageBox.Show("Max is not valid.");
							goto end;
						}
					} else if (ValidateId(IdInput.Text)) {
						if (LimitInput.Text.Length == 0) {
							l = -1;
						} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							MessageBox.Show("Max is not valid.");
							goto end;
						}
					} else {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					if (!Int64.TryParse(CursorInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out c)) {
						MessageBox.Show("Cursor is not valid integer.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(DownloadChallengeVideos)).Start(new Download {
						Id = IdInput.Text,
						Limit = l,
						IsMax = true,
						Cursor = c
					});
					return;
				default://3
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id is empty.");
						goto end;
					} else if (LimitInput.Text.Length == 0) {
						l = -1;
					} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
						MessageBox.Show("Max is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(DownloadVideos)).Start(new Download {
						Id = IdInput.Text,
						Limit = l,
						IsMax = true,
						Cursor = 0
					});
					return;
			}
			end: EnableControls();
		}
		/*public static bool ValidateRemoteCertificate(object sender, object certificate, object chain, SslPolicyErrors sslPolicyErrors) {
			return true;
		}*/
		[STAThread]
		public static void Main() {
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			ServicePointManager.SecurityProtocol |= SecurityProtocolType.Ssl3 | SecurityProtocolType.Tls | SecurityProtocolType.Tls11 | SecurityProtocolType.Tls12 | SecurityProtocolType.Tls13;//.NET 4.8
			//ServicePointManager.ServerCertificateValidationCallback += ValidateRemoteCertificate;//.NET 3.5
			string a = Environment.GetCommandLineArgs()[0], d = Path.GetDirectoryName(a);
			d += d.Length > 0 ? Path.DirectorySeparatorChar + "download" : "download";
			try {
				if (!Directory.Exists(d)) {
					Directory.CreateDirectory(d);
				}
				Directory.SetCurrentDirectory(d);
			} catch {
				MessageBox.Show("Could not initialize download directory.");
				return;
			}
			Application.Run(new MainForm(Path.GetDirectoryName(d), Path.GetFileName(d)));
		}
	}
}